#!/usr/local/bin/perl
#
# start page for FreEasy, shows how many users are logged on,
# and the disk info

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 

require 5.002;

use lib '/usr/src/FreEasy/lib';
use CGI qw(:standard :html3);

@devices = return_CDROM_devices();

print 
    header,
    start_html(
	       -title=>'Media CDROM select list', 
	       -bgcolor=>'#ffffff'),
    h1('<font color="#660000">Please select a CDROM from the list</font>'),
    p,
    "Please select a CDROM from the list below which you want to use to ",
    "install the packages to your harddisk.",
    p,
    start_form('get', 'http:nph-pkg_index.pl'),
    table({-cols=>2, -width=>"80\%"},
	  Tr({-align=>LEFT}, 
	     [
	      td(['Select your CDROM: ',
		  popup_menu(-name=>'devCDROM',
			     -values=>['<specify other device>', sort @devices],
			     -default=>@devices[0])]),
	      td(["Select your mount point: ",
		  textfield(-name=>'dir',
			    -value=>'/cdrom',
			    -size=>50)]),
	     ],
	    )
	 ),
    p,
    "\n",
    hidden(-name=>'media',
	   -value=>'cdrom'),
    "\n",
    submit(-value=>'OK'),
    '&nbsp',
    reset,
    end_form,
    end_html;

sub return_CDROM_devices () {

    my %devices = ();
    @CDROMDevices = ("cd0a","SCSI CDROM drive","mcd0a","Mitsumi (old model) CDROM drive","scd0a","Sony CDROM drive - CDU31/33A type","matcd0a","Matsushita CDROM ('sound blaster' type)","wcd0c","ATAPI IDE CDROM (primary)","wcd0c","ATAPI IDE CDROM (secundary)");
    fd = 0;

    for (i = 0; i <= 12; i += 2;) {

	fd = deviceTry($CDROMDevices[i]);

    return %devices;
}

sub deviceTry {

    my($name) = @_;

    $try = "";
    $fd = 0;
    
    $try = "/dev/$name";
    # snprintf(try, FILENAME_MAX, "/dev/%s", name);
    fd = open($try, O_RDONLY);
    if (fd > 0)
	return fd;
    if ($! == EBUSY)
	return -1;
    $try = "/mnt/dev/$name";
    # snprintf(try, FILENAME_MAX, "/mnt/dev/%s", name);
    fd = open(try, O_RDONLY);
    return fd;
}
