#!/usr/local/bin/perl

#
# Display all known ftp distribution servers
# Created: 1998-02-12

# Copyright (c) 1998 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 

use lib '/usr/src/FreEasy/lib';
use CGI qw(:standard :html3);
use access_INDEX;


%servers = ();
(%servers) = get_package_ftp_servers();


print 
    header,
    start_html(
	       -title=>'Media FTP select list', 
	       -bgcolor=>'white'),
    h1('<font color="#660000">Please select a FreeBSD FTP distribution site</font>'),
    p,
    "Please select the site closest to you or \"other\" if you'd like to ",
    "specify a different choice. Also note that not every site listed here ",
    "carries more than the base distribution kits. Only the Primary site is ",
    "guaranteed to carry the full range of possible distributions.",
    p,
    "Select a site that's close!",
    start_form('get', 'http:nph-pkg_index.pl'),
    table({-cols=>2, -width=>"80\%"},
	  Tr({-align=>LEFT}, 
	     [
	      td(['Your distribution server: ',
		  popup_menu(-name=>'ftpserver',
			     -values=>['<specify other site>', sort keys %servers],
			     -default=>'Primary Site')]),
	      td(["Specify complete URL for 'other site' ftp server: ",
		  textfield(-name=>'otherftpserver',
			    -size=>50)]),
	      td(['', "This URL should be of the form 'ftp://ftp.FreeBSD.org/pub/FreeBSD/'. You should exclude the packages subdirectory itself."]),
	      td(["I'm behind a firewall, so use passive mode FTP transfer",
		  checkbox(-name=>'ftpmode', 
			   -value=>'passive',
			   -label=>'')])
	     ],
	    )
	 ),
    p,
    "\n",
    hidden(-name=>'media',
	   -value=>'ftp'),
    "\n",
    submit(-value=>'OK'),
    '&nbsp',
    reset,
    end_form,
    end_html;




