#!/usr/local/bin/perl

#
# add a given package
# Created: 1998-02-12

# Copyright (c) 1998 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use CGI;

#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/bin:/usr/bin";


$form = new CGI;

$pkgname = $form->param('pkgname');
$URL = $form->param('URL');
$Confirm = $form->param('confirm');

#we keep the selected media list ready
$Media = $form->param('media');
$Dir = $form->param('dir');
$ftpserver = $form->param('ftpserver');
$otherftpserver = $form->param('otherftpserver');
$ftpmode = $form->param('ftpmode');
$MediaSelection = "media=$Media&Dir=$Dir&ftpserver=$ftpserver&otherftpserver=$otherftpserver&ftpmode=$ftpmode";
$MediaSelection =~ s/ /\+/g;


if ($Confirm =~ /yes/i) {

    #confirm package installation and ask for parameters
    print $form->header(-nph=>1);
    print $form->start_html(
      -title=>"Confirm adding package $pkgname",
      -BGCOLOR=>'white');

    print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=pkg_add>Consult pkg_add man page</a> |\n";
    print "<a href=http:show_installed_pkg.pl>Show installed packages</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/setup.pl?path=AddRemoveSoftware&title=Add/remove+software\">Add/remove software</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/start.pl>To main screen</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

    print "<h1><font color=\"#660000\">Confirm adding package $pkgname</font></h1>\n";

    print "<form method=get action=http:nph-pkg_add.pl>\n";

    print "<p><input type=checkbox name=noscript value=\"noscript\">If an installation script exists for this package, do not execute it. If an installation script exists for this package which requires interactive input, you probably shouldn't install it through your browser as not all packages let you easily modify their options later.</p>\n";

    print "<p><input type=checkbox name=forceadd value=\"forceadd\">Force installation to proceed even if prerequisite packages are not installed or the requirements script fails. Although pkg_add will still try to find and auto-install missing prerequisite packages, a failure to find one will not be fatal.</p>\n";

    print "<input type=hidden name=pkgname VALUE=\"$pkgname\">\n";
    print "<input type=hidden name=URL VALUE=\"$URL\">\n";
    print "<input type=hidden name=confirm VALUE=No>\n";
    print "<input type=hidden name=media VALUE=$Media>\n";
    print "<input type=hidden name=dir VALUE=\"$Dir\">\n";
    print "<input type=hidden name=ftpserver VALUE=\"$ftpserver\">\n";
    print "<input type=hidden name=otherftpserver VALUE=\"$otherftpserver\">\n";
    print "<input type=hidden name=ftpmode VALUE=\"$ftpmode\">\n";

    print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Add package now!\">\n";
    print "<INPUT TYPE=\"RESET\">\n";
    print "</form>\n";
    print $form->end_html;

}
else {

    # turn output buffering off;
    $| = 1;

    print $form->header(-nph=>1,
			-type=>'multipart/x-mixed-replace;boundary=NEXT');
    print "--NEXT\n";

    print $form->header(-type=>'text/html');
    print $form->start_html(
      -title=>"Retrieving package",
      -BGCOLOR=>'white');
    print "<p>Retrieving package, please wait...</p>\n";
    print $form->end_html;
    print "\n--NEXT\n";

    print $form->header(-type=>'text/html');
    print $form->start_html(
      -title=>"Adding package",
      -BGCOLOR=>'white');
    print "<p>Adding package:</p>\n";
    
    open (FILE, "- |") or exec '/usr/sbin/pkg_add', "$URL";
    while (<FILE>) {
	print $_;
    }
    close FILE;

    print $form->end_html;
    print "\n--NEXT\n";

    print $form->header(-type=>'text/html');
    print $form->start_html(
      -title=>"Package $pkgname added",
      -BGCOLOR=>'white');

    print "<a href=\"http:nph-pkg_index.pl?$MediaSelection\">Add new package</a> |\n";
    print "<a href=http:show_installed_pkg.pl>Show installed packages</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/setup.pl?path=AddRemoveSoftware&title=Add/remove+software\">Add/remove software</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/start.pl>To main screen</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

    print "<h1>Package $pkgname added</h1>\n";
    print "<p>Warning: a failure to add a package is not yet catched!\n";
    print "You should check if it is really installed or not.</p>\n";
    print $form->end_html;
    print "\n--NEXT\n";
}




