#!/usr/local/bin/perl

#
# show list of packages which can be installed
# Created: 1998-02-11

# Copyright (c) 1998 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/src/FreEasy/lib';
use Sys::Hostname;
use CGI;
use access_INDEX;


$HostName = hostname();
$form = new CGI;

$Media = $form->param('media');
$Dir = $form->param('dir');
if ($Dir =~ /\/$/) { chop $Dir; }
$PkgIndex = $form->param('pkgindex');
$ftpserver = $form->param('ftpserver');
$otherftpserver = $form->param('otherftpserver');
$ftpmode = $form->param('ftpmode');


if ($Media eq '') {

    #if media not specified, select it first
    print $form->redirect("http://$HostName/FreEasy/AddRemoveSoftware/SelectMedia.html");

}

else {

    # turn output buffering off;
    $| = 1;

    print $form->header(-nph=>1,
			-type=>'multipart/x-mixed-replace;boundary=NEXT');
    print "--NEXT\n";

    print $form->header(-type=>'text/html');
    print $form->start_html(
      -title=>"Retrieving  index",
      -BGCOLOR=>'#ffffff');
    print "<p>Retrieving index, please wait...</p>\n";

    #make sure we have the INDEX file
    if ($Media eq 'directory') {
	$Index = "$Dir/packages/INDEX";
	$URL="file:$Dir";
    }
    elsif ($Media eq 'ftp') {
	%ftpservers = ();
	(%ftpservers) = get_package_ftp_servers();
	if ($ftpserver eq '<specify other site>') {
	    $URL = $otherftpserver;
	    if ($URL !~ /\/$/) { $URL = "$URL/"; }
	}
	else {
	    $URL = $ftpservers{$ftpserver}{'URL'};
	}
	$Index = '/tmp/INDEX';	
	if ( !(-e $Index) ) {
	    #retrieve INDEX from ftp and store it in /tmp
	    require Net::FTP;
	    #really should catch a failed require here
	    $ftpservername = $URL;
	    $ftpservername =~ s/^.*\/\///;
	    @fields = split /\//, $ftpservername, 2;
	    $ftpservername = $fields[0];
	    $ftpdir = "/${fields[1]}packages";
	    print "<p>Login to $ftpservername...</p>\n";
	    if ($ftpmode eq 'passive') {
		$ftp = Net::FTP->new("$ftpservername", ('Passive', 'true'));
	    }
	    else {
		$ftp = Net::FTP->new("$ftpservername");
	    }
	    if ( !(defined $ftp)) {
		print "<p>Login failed. You may try it again by reloading this page.</p>\n";
		print $form->end_html;
		print "\n--NEXT\n";
		exit;
	    }
	    $ftp->login();
	    print "<p>Login successfull.</p>\n";
	    $ftp->cwd("$ftpdir");
	    print "<p>Getting INDEX file...</p>\n";
	    $ftp->get("INDEX", "/tmp/INDEX");
	    $ftp->quit;
	    print "<p>Getting INDEX file successfull.</p>\n";
	}
    }
    print $form->end_html;
    print "\n--NEXT\n";

    $| = 0;
    print $form->header(-type=>'text/html');
    print $form->start_html(
      -title=>"Select the package to add",
      -BGCOLOR=>'white');

    print "<a href=http:show_installed_pkg.pl>Show installed packages</a> |\n";
    print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=pkg_add>Consult pkg_add man page</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/setup.pl?path=AddRemoveSoftware&title=Add/remove+software\">Add/remove software</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/start.pl>To main screen</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

    print "<h1 align=center><font color=\"#660000\">Add a package</font></h1>\n";

    # print either the index or (all) packages (in the index)
    if ($PkgIndex eq '') {

	%indexdesc = ();
	%indexalias = ();
	%indexkeyword = ();
	%keywords = ();
	(%indexdesc) = get_INDEX_desc();
	(%indexalias) = get_INDEX_alias();
	(%indexkeyword) = get_INDEX_keyword();

	#get list of keywords
	%pkgs = ();
	open (FILE, $Index);
	while (<FILE>) { 
	    @fields = split /\|/;
	    foreach $keyword (split / /, $fields[6]) {
		if (exists $indexalias{$keyword}) { 
		    $keyword = $indexalias{$keyword};
		}	    
		if ( ! (exists $keywords{$keyword}) ) {
		    $keywords{$keyword} = 1;
		}
	    }
	}
	close (FILE);
    
	print "<table cols=2 width=\"80%\">\n";
	print "<tr>\n";
	print "<th align=left><font face=\"Arial,Helvetica\">Package</font></th>\n";
 	print "<th align=left><font face=\"Arial,Helvetica\">Short description</font></th>\n";
	print "</tr>\n";
	print "<tr><td width=\"30%\">&nbsp</td><td width=\"70%\">&nbsp</td></tr>\n";

	$params = "media=$Media&Dir=$Dir&ftpserver=$ftpserver&otherftpserver=$otherftpserver&ftpmode=$ftpmode&pkgindex=All";
	$params =~ s/ /\+/g;
	print $form->Tr($form->td([$form->a({-href=>"http:nph-pkg_index.pl?$params"}, 'All'), 'All available packages in all categories'])), "\n";

	foreach $keyword (sort keys %keywords) {

	    print "<tr><td>";
	    if (exists $indexkeyword{$keyword}) { 
		$rel = $indexkeyword{$keyword};
	    }
	    else { $rel = $keyword; }
	    $params = "media=$Media&Dir=$Dir&ftpserver=$ftpserver&otherftpserver=$otherftpserver&ftpmode=$ftpmode&pkgindex=$keyword";
	    $params =~ s/ /\+/g;
	    print $form->a({-href=>"http:nph-pkg_index.pl?$params"}, $rel);
	    print "</td><td>";
	    if ( exists $indexdesc{$keyword} ) {
		print $indexdesc{$keyword};
	    }
	    else {
		print "No description provided.";
	    }
	    print "</td></tr>\n";  
	    
	}

    }
    else {
	print "<table cols=3 width=\"90%\">\n";
	print "<tr>\n";
	print "<th align=left><font face=\"Arial,Helvetica\">Package</font></th>\n";
	print "<th align=left><font face=\"Arial,Helvetica\">Short description</font></th>\n";
	print "<th align=left><font face=\"Arial,Helvetica\">Maintainer</font></th>\n";
	print "</tr>\n";

	print "<tr><td width=\"20%\">&nbsp</td><td width=\"60%\">&nbsp</td><td>&nbsp</td></tr>\n";

	#get list of relevant packages
	%pkgs = ();
	open (FILE, $Index);
	while (<FILE>) { 
	    @fields = split /\|/;
	    if ( ($PkgIndex eq 'All') || ($fields[6] =~ /$PkgIndex/) ) {
		$pkgs{$fields[0]}{'descr'} = $fields[3];
		$pkgs{$fields[0]}{'maintainer'} = $fields[5];
	    }
	}
	close (FILE);

	# and display it
	foreach $pkg (sort keys %pkgs) {
	    $params = "media=$Media&Dir=$Dir&ftpserver=$ftpserver&otherftpserver=$otherftpserver&ftpmode=$ftpmode";
	    $params =~ s/ /\+/g;
	    $FileURL = "${URL}packages-stable/$PkgIndex/$pkg.tgz";
	    print "<tr><td><a href=\"nph-pkg_add.pl?$params&pkgname=$pkg&URL=$FileURL&confirm=Yes\">$pkg</a></td><td>$pkgs{$pkg}{'descr'}</td><td><a href=\"mailto:$pkgs{$pkg}{'maintainer'}\">$pkgs{$pkg}{'maintainer'}</a></td></tr>\n";
	}

    }

    print "</table>\n";

    print $form->end_html;
    print "\n--NEXT\n";

}


