#!/usr/local/bin/perl

#
# show list of installed packages
# Created: 1998-01-15

# Copyright (c) 1998 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use CGI qw(:standard :html3);
use Sys::Hostname;

$HostName = hostname();
$form = new CGI;

$pkg_name = '';
$comment_start = -1;


# retrieve list if installed packages
%packages = ();

open(pkg_info, "pkg_info -ac |");

while ($Line = <pkg_info>) {
    $name_start = index $Line, 'Information for';
    if ( $name_start == 0) {
	$pkg_name = substr $Line, $name_start + 16;
	$pkg_name = substr $pkg_name, 0, -2;
	$comment_start = -1;
    }
    if (( $pkg_name ne '') && ( $comment_start == 0)) {
	$packages{$pkg_name} = $Line;
	#print "<tr><td><a href=\"pkg_details.pl?pkgname=$pkg_name\">$pkg_name</a></td><td>$Line</td></tr>\n";
	$pkg_name = '';
	$comment_start = -1;	
    }
    $comment_start = index $Line, 'Comment:';
}

close(pkg_info);


@rows = ();
foreach $pkg (sort keys %packages) {
    push(@rows, td([a({-href=>"pkg_details.pl?pkgname=$pkg"}, $pkg), $packages{$pkg}]));
}

print 
    header,
    start_html(-title=>"Packages installed on $HostName",
	       -BGCOLOR=>'white');

    print "<a href=http:nph-pkg_index.pl>Add new package</a> |\n";
    print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=pkg_info>Consult pkg_info man page</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/setup.pl?path=AddRemoveSoftware&title=Add/remove+software\">Add/remove software</a> |\n";
    print "<a href=http:/FreEasy/cgi-bin/start.pl>To main screen</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

print
    h1({-align=>CENTER}, "<font color=\"#660000\">Packages installed on this system</font>"),
    "\n",
    table({-cols=>2, -width=>"80%"}, 
	   Tr({-align=>LEFT},
	      [
	       th(['Package', 'Short description']),
	       Tr(\@rows)
	       ]
	      )
	  );
		   

#print "<tr>\n";
#print "<th align=left><font face=\"Arial,Helvetica\">Package</font></th>\n";
#print "<th align=left><font face=\"Arial,Helvetica\">Short description</font></th>\n";
#print "</tr>\n";

#print "<tr><td></td><td></td></tr>\n";


print $form->end_html;


