#!/usr/local/bin/perl
#
# Change virtual terminals

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_ttys;


#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


$form = new CGI;


# set single user security mode
$Secure = $form->param('securesingleuser');
if ($Secure eq '') { $Secure = 'secure'; }
$singleusermodified = change_single_user_security($Secure);

# set terminals
$VirtualTerminals = 12;
%ttys = ();

for ($Counter = 0; $Counter < $VirtualTerminals; $Counter++) {

    $tty = sprintf "ttyv%x", $Counter;
    $ttys{$tty}{'type'} = $form->param("type$tty");
    $ttys{$tty}{'on'} = $form->param("console$tty");
    if ($ttys{$tty}{'on'} eq '') { $ttys{$tty}{'on'} = 'off'; }
    $ttys{$tty}{'secure'} = $form->param("secure$tty");
    if ($ttys{$tty}{'secure'} eq '') { $ttys{$tty}{'secure'} = 'insecure'; }

}
$modified = change_virtual_consoles(%ttys);


print $form->header;

if ($singleusermodified || $modified) {

    print $form->start_html(
	    -title=>'Virtual terminals settings changed',
	    -BGCOLOR=>'white');
    
    print "<center><h1><font color=\"#660000\">Virtual terminal settings changed.</font></h1></center>\n";

    print "<center>\n";

	if ($Secure =~ /^insecure$/i) {
	    print "<p>If you boot into single user mode, you're asked for the root password.</p>\n";
	}
    else {
	    print "<p>If you boot into single user mode, you're not asked for a password.</p>\n";
    }

    if ($modified) {
	print "<p>Your virtual terminal setup has been changed. Changes have taken effect immediately.</p>\n";
    }
    else {
	print "<p>Your virtual terminal setup has not been changed.</p>\n";
    }
    
    print "</center>\n";

    #make sure we have every tty device
    $remake_devices = 0;
    for ($Counter = 0; $Counter < $VirtualTerminals; $Counter++) {

	$tty = sprintf "ttyv%x", $Counter;
	if ( !(-e "/dev/$tty") ) {
	    $remake_devices = 1;
	    last;
	}
    }
    if ($remake_devices) {
	system '/bin/sh', '-c', 'cd /dev; ./MAKEDEV vty12';
    }

    #reinit init
    system('/bin/kill -1 1');

    #finally set screen size for every console (assume VGA...)
    for ($Counter = 0; $Counter < $VirtualTerminals; $Counter++) {
	$tty = sprintf "ttyv%x", $Counter;
	if ($ttys{$tty}{'on'} eq 'on') {
	    if ($ttys{$tty}{'type'} =~ /cons25/) {
		system '/bin/sh', '-c', 
		"/usr/sbin/vidcontrol VGA_80x25 < /dev/$tty";
	    }
	    elsif ($ttys{$tty}{'type'} =~ /cons30/) {
		system '/bin/sh', '-c', 
		"/usr/sbin/vidcontrol VGA_80x30 < /dev/$tty";
	    }
	    elsif ($ttys{$tty}{'type'} =~ /cons43/) {
		system '/bin/sh', '-c', 
		"/usr/sbin/vidcontrol EGA_80x43 < /dev/$tty";
	    }
	    elsif ($ttys{$tty}{'type'} =~ /cons50/) {
		system '/bin/sh', '-c', 
		"/usr/sbin/vidcontrol VGA_80x50 < /dev/$tty";
	    }
	    elsif ($ttys{$tty}{'type'} =~ /cons60/) {
		system '/bin/sh', '-c', 
		"/usr/sbin/vidcontrol VGA_80x60 < /dev/$tty";
	    }
	}
    }
}

else {

    print $form->start_html(
	    -title=>'Virtual terminals settings unchanged',
	    -BGCOLOR=>'white');

    print "<center><h1><font color=\"#660000\">Virtual terminal settings unchanged.</font></h1></center>\n";

}


print "<center><table>\n";

print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"Back to main ";
print "screen\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=Console&title=Change+FreeBSD+console+settings\">\n";
print "<IMG SRC=\"/FreEasy/Icons/displaybutton.gif\" ALT=\"Back to ";
print "Console menu\" BORDER=0></A></TD>\n";

print "</table></center>\n";

#
# End HTML form
#

print $form->end_html;

# changeconsole.pl
