#!/usr/local/bin/perl
#
# Change system console fonts settings
# expects to be  setuid root!
#

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;


#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


$form = new CGI;

#
# extract vars from form
# and change corresponding rc.conf

%vars = ();
%oldvars = ();
$vars{'font8x8'} = $form->param('font8');
$vars{'font8x14'} = $form->param('font14');
$vars{'font8x16'} = $form->param('font16');

($modified, %oldvars) = rcconf_change_vars(%vars);


#if something changed, set fonts now
if ($modified) {

    print $form->header;
    print $form->start_html(
       -title=>'Font properties changed',
       -BGCOLOR=>'white');

    if ($vars{'font8x8'} eq $oldvars{'font8x8'}) {
      print "<CENTER><H3>Screen 80x50 font not changed.</H3>\n";
    } else {
        print "<CENTER><H3>Screen 80x50 font changed from $oldvars{'font8x8'} to $vars{'font8x8'}";
	print "</H3>\n";
	if ($vars{'font8x8'} eq "NO") {
	    if ($oldvars{'font8x8'} ne "NO") {
		system "/bin/sh", '-c', "/usr/sbin/vidcontrol -f 8x8 cp437-8x8.fnt < /dev/ttyv0";
	    }
	}
	else {
	    system "/bin/sh", '-c', "/usr/sbin/vidcontrol -f 8x8 $vars{'font8x8'} < /dev/ttyv0";
        }
    }

    if ($vars{'font8x14'} eq $oldvars{'font8x14'}) {
      print "<H3>Screen 80x43 font not changed.</H3>\n";
    } else {
        print "<H3>Screen 80x43 font changed from $oldvars{'font8x14'} to $vars{'font8x14'}</H3>\n";
	if ($vars{'font8x14'} eq "NO") {
	    if ($oldvars{'font8x14'} ne "NO") {
		system "/bin/sh", '-c', "/usr/sbin/vidcontrol -f 8x14 cp437-8x14.fnt < /dev/ttyv0";
	    }
	}
	else  {
	    system "/bin/sh", '-c', "/usr/sbin/vidcontrol -f 8x14 $vars{'font8x14'} < /dev/ttyv0";
	}
    }

    if ($vars{'font8x16'} eq $oldvars{'font8x16'}) {
      print "<H3>Screen 80x25 f not changed.</H3>\n";
    } else {
        print "<H3>Screen 80x25 font changed from $oldvars{'font8x16'} to $vars{'font8x16'}</H3>\n";
	if ($vars{'font8x16'} eq "NO") {
	    if ($oldvars{'font8x16'} ne "NO") {
		system "/bin/sh", '-c', "/usr/sbin/vidcontrol -f 8x16 cp437-8x16.fnt < /dev/ttyv0";
	    }
	}
	else {
	    system "/bin/sh", '-c', "/usr/sbin/vidcontrol -f 8x16 $vars{'font8x16'} < /dev/ttyv0";
        }
    }

    print "<P>If you see no changes, remember 8x16 is for a 80x25 sized \n";
    print "screen, 8x14 is for a 80x43 sized screen and 8x8 is for a ";
    print "80x50 sized screen.</P>\n";

}
else {

  print $form->header;
  print $form->start_html(
      -title=>'System console font not changed',
      -BGCOLOR=>'white');
  print "<CENTER><H3>System console font not changed.</H3>\n";

}


print "<CENTER><TABLE>\n";

print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"Back to main ";
print "screen\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=Console&title=Change+FreeBSD+console+settings\">\n";
print "<IMG SRC=\"/FreEasy/Icons/displaybutton.gif\" ALT=\"Back to ";
print "Console menu\" BORDER=0></A></TD>\n";

print "</TABLE></CENTER>\n";

#
# End HTML form
#

print $form->end_html;

# changefonts.pl
