#!/usr/local/bin/perl
#
# Change keyboard settings
# assumes it is run setuid

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;
use writecustomkeymap;

#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


$form = new CGI;


# extract vars from form
# and change corresponding rc.conf

%vars = ();
%oldvars = ();
$vars{'cursor'} = $form->param('cursor');
$vars{'keyrate'} = $form->param('keyrate');
$vars{'keymap'} = $form->param('keymap');
for $FunctionKey (1 .. 12) {
    $FValue = $form->param("F$FunctionKey");
    if ($FValue ne '') {
	$vars{'keychange'} = "$vars{'keychange'} $FunctionKey $FValue";
    }
}
$vars{'keychange'} =~ s/^\s+//;         # trim spaces
if ($vars{'keychange'} eq '') {
    $vars{'keychange'} = 'NO';
}

($modified, %oldvars) = rcconf_change_vars(%vars);


#if something changed, let it take effect immediately
if ($modified) {

    print $form->header;
    print $form->start_html(
      -title=>'Keyboard properties changed',
      -BGCOLOR=>'white');
    print "<CENTER>";

    if ($oldvars{'cursor'} eq $vars{'cursor'}) {
	print "<P>Cursor type not changed.\n";
    } else {
	print "<P>Cursor type changed from $oldvars{'cursor'} to ";
        print "$vars{'cursor'}\n";
	if ($vars{'cursor'} eq "NO") {
	    system "/bin/sh", '-c', "/usr/sbin/vidcontrol -c normal < /dev/ttyv0";
	}
	else {
	    system "/bin/sh", '-c', "/usr/sbin/vidcontrol -c $vars{'cursor'} < /dev/ttyv0";
	}
    }

    if ($oldvars{'keyrate'} eq $vars{'keyrate'}) {
	print "<P>Keyboard repeat speed not changed.\n";
    } else {
	print "<P>Keyboard repeat speed changed from  $oldvars{'keyrate'} to $vars{'keyrate'}\n";
	if ($vars{'keyrate'} eq "NO") {
	    system "/bin/sh", '-c', "/usr/sbin/kbdcontrol -r normal < /dev/ttyv0";
	}
	else {
	    system "/bin/sh", '-c', "/usr/sbin/kbdcontrol -r $vars{'keyrate'} < /dev/ttyv0";
	}
    }

    if ($oldvars{'keymap'} eq $vars{'keymap'}) {
	print "<P>Keyboard map not changed.\n";
    } 
    else {
	print "<P>Keyboard map changed from $oldvars{'keymap'} to $vars{'keymap'}\n";
	if ($vars{'keymap'} eq "NO") {
	    system "/bin/sh", '-c', "/usr/sbin/kbdcontrol -l us.cp850 < /dev/ttyv0";
	}
	else {
	    system "/bin/sh", '-c', "/usr/sbin/kbdcontrol -l $vars{'keymap'} < /dev/ttyv0";
	}
    }

    for $FunctionKey (1 .. 12) {
	$FValue = $form->param("F$FunctionKey");
	print "<P>Function key F$FunctionKey changed to \"$FValue\"\n";
	system "/bin/sh", '-c', "/usr/sbin/kbdcontrol -f $FunctionKey '$FValue' < /dev/ttyv0";
    }

   
    print "<P>Changes have taken effect immediately.\n";

}
else {

    print $form->header;
    print $form->start_html(
      -title=>'Console keyboard settings not changed',
       -BGCOLOR=>'white');
    print "<CENTER><H3>Console keyboard settings not changed.</H3>\n";

}



print "<TABLE>\n";

print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=Setup";
print "&title=Setup+your+System\">\n";
print "<IMG SRC=\"/FreEasy/Icons/setupbutton.gif\" ALT=\"BACK TO SETUP ";
print "SCREEN\" BORDER=0></A></TD>\n";

print "</TABLE>\n";

print "</CENTER>\n";

#
# End HTML form
#

print $form->end_html;

# changekeyboard.pl
