#!/usr/local/bin/perl
#
# Change moused settings
# expects to be  setuid root!
#

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;


#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


$form = new CGI;

#
# extract vars from form
# and change corresponding rc.conf
%vars = ();
%oldvars = ();
$vars{'moused_type'} = $form->param('moused_type');
$vars{'moused_port'} = $form->param('moused_port');
$vars{'moused_flags'} = '';
$baudrate = $form->param('moused_port');
$explicitport = $form->param('explicitport');
$explicitbaudrate = $form->param('explicitbaudrate');

if ($vars{'moused_port'} eq 'other') {
    $vars{'moused_port'} = $explicitport;
}
if (!($vars{'moused_port'} =~ /\/dev\//)) {
    $vars{'moused_port'} = "/dev/$vars{'moused_port'}";
}

if ($baudrate eq 'other') {
    $baudrate = $explicitbaudrate;
}
if ( ($baudrate != 1200) && ($baudrate =~ /^\d+$/) ) {
    $vars{'moused_flags'} = '-s $baudrate';
}
if ($form->param('chordmiddle') == 1) {
    $vars{'moused_flags'} = "$vars{'moused_flags'} -c";
}
if ($form->param('lowerdtr') == 1) {
    $vars{'moused_flags'} = "$vars{'moused_flags'} -D";
}
if ($form->param('lowerrts') == 1) {
    $vars{'moused_flags'} = "$vars{'moused_flags'} -R";
}

($modified, %oldvars) = rcconf_change_vars(%vars);


#
# Extract value of all added text and buttons
# The name  must  match the name in the
# Web page for this input field.
#


#if something changed, bring up/down mouse now
if ($modified) {

    print $form->header;
    print $form->start_html(
       -title=>'moused options changed',
       -BGCOLOR=>'white');

    # kill existing moused first
    open FILE, "/bin/ps -axc |";
    $Line = <FILE>;                     # skip header
    while ($Line = <FILE>) {
	$Line =~ s/^\s+//;              # trim spaces
	@fields = split /\s+/, $Line;
	#print "<P>$fields[0], $fields[4], $fields[5]</P>";
	if ( $fields[4] eq 'moused' ) {
	    system "/bin/kill", $fields[0];
	    last;
	}
    }
    close FILE;

    print "<CENTER>";
    if ($vars{'moused_type'} eq "NO") {
	system '/bin/sh', '-c', "/usr/sbin/vidcontrol -m off < /dev/ttyv0";
    } 
    else {
	system '/bin/sh', '-c', "/usr/sbin/moused $vars{'moused_flags'} -p $vars{'moused_port'} -t $vars{'moused_type'}";
	system '/bin/sh', '-c', "/usr/sbin/vidcontrol -m on < /dev/ttyv0";
    }

    if ($vars{'moused_type'} eq $oldvars{'moused_type'}) {
      print "<H3>Mouse type not changed.</H3>\n";
    } 
    else {
	print "<H3>Mouse type changed from $oldvars{'moused_type'} to ";
	print "$vars{'moused_type'}</H3>\n";
    }

    if ($vars{'moused_port'} eq $oldvars{'moused_port'}) {
	print "<H3>Mouse I/O port not changed.</H3>\n";
    } 
    else {
        print "<H3>Mouse I/O port changed from $oldvars{'moused_port'} to $vars{'moused_port'}</H3>\n";
      }

    if ($vars{'moused_flags'} eq $oldvars{'moused_flags'}) {
	print "<H3>moused flags not changed.</H3>\n";
    } 
    else {
        print "<H3>moused flags changed from $oldvars{'moused_flags'} to $vars{'moused_flags'}</H3>\n";
    }
    print "<P>Changes have taken effect immediately.</P></CENTER>\n";
    if ($vars{'moused_type'} ne "NO") {
	print "<P>Note that mouse support is only enabled for your first\n";
	print "console, ttyv0. If you want mouse support in other consoles,\n";
	print "type</P>\n";
	print "<spacer type=horizontal size=10><tt>vidcontrol -m on</tt></P>\n";
	print "in that console to enable the\n";
	print "mouse for that console.</P>\n";
    }

}
else {

  print $form->header;
  print $form->start_html(
      -title=>'moused options not changed',
      -BGCOLOR=>'white');
  print "<CENTER><H3>moused options not changed.</H3>\n";

}

print "<CENTER><TABLE>\n";
print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=Setup";
print "&title=Setup+your+System\">\n";
print "<IMG SRC=\"/FreEasy/Icons/setupbutton.gif\" ALT=\"BACK TO SETUP ";
print "SCREEN\" BORDER=0></A></TD>\n";
print "</TABLE></CENTER>\n";

#
# End HTML form
#

print $form->end_html;

# changemouse.pl
