#!/usr/local/bin/perl
#
# Change console screensaver settings
# expects to be  setuid root!
#

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;

#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


$form = new CGI;

# extract vars from form
# and change corresponding rc.conf

%vars = ();
%oldvars = ();
$vars{'saver'} = $form->param('saver');
$vars{'blanktime'} = $form->param('blanktime');

($modified, %oldvars) = rcconf_change_vars(%vars);


#if something changed, (re)start the screensaver
if ($modified) {

    print $form->header;
    print $form->start_html(
       -title=>'Screensaver settings changed',
       -BGCOLOR=>'white');

    # if any screensaver runs, shut it down
    open FILEIN, "/usr/bin/modstat |";
    $Line = <FILEIN>;                   # skip header
    while ($Line = <FILEIN>) {
	@fields = split /\s+/, $Line;
	if ( $fields[7] =~ /_saver_mod/ ) {
	    system "/sbin/modunload", '-i', $fields[1];
	    last;
	}
    }
    close FILEIN;

    # if user wants to run a saver, start it now
    if ( $vars{'saver'} ne "NO" ) {
	$arg = "/lkm/$vars{'saver'}_saver_mod.o";
	system "/sbin/modload", '-u', '-o', '/tmp/saver_mod', '-q', "/lkm/$vars{'saver'}_saver_mod.o";
    }

    # set blanktime
    system "/bin/sh", '-c', "/usr/sbin/vidcontrol -t $vars{'blanktime'} < /dev/ttyv0";

    #return info to user
    print "<CENTER><H3>Screensaver changed from $oldvars{'saver'} to $vars{'saver'}\n";
    print "<H3>Blanktime changed to $vars{'blanktime'} seconds</H3>\n";
    print "<P>Changes have taken effect immediately.\n";
    
}
else {

    print $form->header;
    print $form->start_html(
	    -title=>'Screensaver settings not changed',
	    -BGCOLOR=>'white');
    print "<CENTER><H3>Screensaver settings not changed.</H3>\n";

}


print "<CENTER><TABLE>\n";

print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=Console&title=Change+FreeBSD+console+settings\">\n";
print "<IMG SRC=\"/FreEasy/Icons/displaybutton.gif\" ALT=\"Back to ";
print "Console menu\" BORDER=0></A></TD>\n";

print "</TABLE></CENTER>\n";

#
# End HTML form
#

print $form->end_html;

# changescrnsaver.pl




