#!/usr/local/bin/perl
#
# Change FreeBSD's virtual consoles

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_ttys;


$VirtualTerminals = 12;

$form = new CGI;

#
# Print form header
#

print $form->header;
print $form->start_html(
   -title=>'Setup virtual terminals',
   -BGCOLOR=>'white');


#
# get available ttys
%ttys = ();
(%ttys) = ttys_get_all_entries();
%termtypes = get_all_console_types();

print "<form method=get action=http:changeconsoles.pl>\n";

#
# Heading
#

print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=init&apropos=0&sektion=8>Consult init man page</a> |\n";
print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=ttys&apropos=0&sektion=5>Consult ttys man page</a> |\n";
print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=termcap&apropos=0&sektion=5>Consult termcap man page</a> |\n";
print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=terminfo&apropos=0&sektion=5>Consult terminfo man page</a>\n";
print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

print "<CENTER>";
print "<H2>Setup FreeBSD's virtual terminals</H2>";
print "</CENTER>\n";

print "<p>Ask for the root password when you go/boot into single user mode:&nbsp&nbsp";
print "<input type=checkbox name=securesingleuser value=\"insecure\"";
if ($ttys{'console'}{'secure'} =~ /^insecure$/i) { print ' checked'; }
print ">\n";
print "</p>\n";

print "<hr size=2>\n";

print "<p>In the first column, you will see the active virtual terminals. \n";
print "You can enable or disable any one of them.";
print "<p>In the second column, a terminal type can be selected like 80x25 or 80x50 screens. FreeBSD's default terminal type is console 80x25\n";
print "<p>In the third column you can make a specific terminal secure or insecure. Users cannot login under the root account on that terminal (but you can use su to become root when you are logged in).\n";

print "<p><table border cols=3 width=\"80%\">\n";

print "<tr>\n";
print "<th><font face=\"Helvetica\">Terminal active<P>(check to enable)</font></th>\n";
print "<th><font face=\"Helvetica\">Console type</font></th>\n";
print "<th><font face=\"Helvetica\">Secure terminal</font></th>\n";
print "</tr>\n";

for ($Counter = 0; $Counter < $VirtualTerminals; $Counter++) {

    print "<tr align=center>\n";

    $tty = sprintf "ttyv%x", $Counter;

    print "<td><input type=checkbox name=console$tty value=\"on\"";
    if ($ttys{$tty}{'on'} =~ /^on$/i) {
	print  ' checked';
    }
    print "><tt>$tty</tt></td>\n";

    print "<td>";
    print "<select name=type$tty>";
    foreach $termtype (sort keys %termtypes) {
	print "<option value=\"$termtype\"";
	if ($ttys{$tty}{'type'} eq $termtype) {
	    print ' selected';
	}
	print ">$termtypes{$termtype}\n";
    }
    print "</select>\n";
    print "</td>\n";

    print "<td>";
    print "<input type=checkbox name=secure$tty value=\"secure\"";
    if ($ttys{$tty}{'secure'} =~ /^secure$/i) {
	print ' checked';
    }
    print ">secure terminal";
    print "</td>";

    print "</tr>\n";

}

print "</table>\n";

print "</center>\n";

print "<P><INPUT TYPE=submit VALUE=\"OK\">\n";
print "<INPUT TYPE=\"RESET\"></P>\n";

print "</FORM>\n";

#
# End HTML form
#

print $form->end_html;

# consoles.pl
