#!/usr/local/bin/perl
#
# Change the display fonts file for FreeBSB

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;
use returnfonts;

$form = new CGI;

#
# get current scrnmap from /etc/rc.conf
#

%vars = ();
(%vars) = rcconf_get_some_vars('font8x8', 'font8x14', 'font8x16');

($Size8x8, $Size8x14, $Size8x16, $Array8x8, $Array8x14, $Array8x16) = return_fonts_name;


#
# Print form header
#

print $form->header;

print $form->start_html(
   -title=>'System console fonts',
   -BGCOLOR=>'white');

#
# HTML body
#

print "<FORM METHOD=\"GET\" ACTION=\"http:changefonts.pl\">\n";


#
# Heading
#

print "<P>Most PC hardware defaults to displaying characters in the\n";
print "IBM 437 character set.  However, in the Unix world, this\n";
print "character set is very rarely used.  Most Western European\n";
print "countries, for example, prefer ISO 8859-1.\n";
print "<P>American users won't notice the difference since the bottom half\n";
print "all these charactersets is ANSI anyway.  However, they might\n";
print "want to load a font anyway to use the 30- or 50-line displays.\n";
print "If your hardware is capable of downloading a new display font ";
print "(if you have a EGA/VGA card for example),\n";
print "you can select the appropriate font below. If you don't have such ";
print "hardware, take look at ";
print "FreeBSD's <A HREF=\"http:scrnmap.pl\">screenmaps</A>\n";

print "<CENTER><H3>Select the fonts which you want to use:</H3>\n";

print "<TABLE>\n";

print "<TR>\n";

print "<TD><B>Screen size 80x50 (font 8x8):</B></TD>\n";
print "<TD><SELECT NAME=\"font8\">\n";

for ($Counter8x8 = 0; $Counter8x8 < $Size8x8; $Counter8x8++) {

  if (@{$Array8x8}[$Counter8x8] eq "NO") {

    if ($vars{'font8x8'} =~ /NO/) {
      print "<OPTION VALUE=\"NO\" SELECTED>No 8x8 font\n";
    } else {
	print "<OPTION VALUE=\"NO\">No 8x8 font\n";
      }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp437-8x8") { 

      if ($vars{'font8x8'} =~ /cp437-8x8/) {
	print "<OPTION VALUE=\"cp437-8x8\" SELECTED>Codepage 437 English\n";
      } else {
	  print "<OPTION VALUE=\"cp437-8x8\">Codepage 437 English\n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp437-thin-8x8") { 

      if ($vars{'font8x8'} =~ /cp437-thin-8x8/) {
	print "<OPTION VALUE=\"cp437-thin-8x8\" SELECTED>Codepage 437 English (thin)\n";
      } else {
	  print "<OPTION VALUE=\"cp437-thin-8x8\">Codepage 437 English (thin)\n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp850-8x8") { 

      if ($vars{'font8x8'} =~ /cp850-8x8/) {
	print "<OPTION VALUE=\"cp850-8x8\" SELECTED>Codepage 850 Multilingual Latin I\n";
      } else {
	  print "<OPTION VALUE=\"cp850-8x8\">Codepage 850 Multilingual Latin I\n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp850-thin-8x8") { 

      if ($vars{'font8x8'} =~ /cp850-thin-8x8/) {
	print "<OPTION VALUE=\"cp850-thin-8x8\" SELECTED>Codepage 850 Multilingual Latin I (thin) \n";
      } else {
	  print "<OPTION VALUE=\"cp850-thin-8x8\">Codepage 850 Multilingual Latin I (thin) \n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp865-8x8") { 

      if ($vars{'font8x8'} =~ /cp865-8x8/) {
	print "<OPTION VALUE=\"cp865-8x8\" SELECTED>Codepage 885 Norwegian\n";
    } else {
	print "<OPTION VALUE=\"cp865-8x8\">Codepage 885 Norwegian\n";
      }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp865-thin-8x8") { 

      if ($vars{'font8x8'} =~ /cp865-thin-8x8/) {
	print "<OPTION VALUE=\"cp865-thin-8x8\" SELECTED>Codepage 885 Norwegian (thin)\n";
      } else {
	  print "<OPTION VALUE=\"cp865-thin-8x8\">Codepage 885 Norwegian (thin)\n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "cp866-8x8") { 

      if ($vars{'font8x8'} =~ /cp866-8x8/) {
	print "<OPTION VALUE=\"cp866-8x8\" SELECTED>Codepage 866 Russian\n";
      } else {
	  print "<OPTION VALUE=\"cp866-8x8\">Codepage 866 Russian\n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "iso-8x8") { 

      if ($vars{'font8x8'} =~ /iso-8x8/) {
	print "<OPTION VALUE=\"iso-8x8\" SELECTED>ISO-8859-1 West European\n";
      } else {
	  print "<OPTION VALUE=\"iso-8x8\">ISO-8859-1 West European\n";
        }
  } elsif (@{$Array8x8}[$Counter8x8] eq "koi8-r-8x8") { 

      if ($vars{'font8x8'} =~ /koi-r-8x8/) {
	print "<OPTION VALUE=\"koi8-r-8x8\" SELECTED>Russian koi8-r\n";
      } else {
	  print "<OPTION VALUE=\"koi8-r-8x8\">Russian koi8-r\n";
        }
  } else {

      if ($vars{'font8x8'} eq @{$Array8x8}[$Counter8x8]) {
	print "<OPTION VALUE=@{$Array8x8}[$Counter8x8] SELECTED>Unknown 8x8 font @{$Array8x8}[$Counter8x8]\n";
      } else {
	  print "<OPTION VALUE=@{$Array8x8}[$Counter8x8]>Unknown 8x8 font @{$Array8x8}[$Counter8x8]\n";
        }
  }
}

print "</SELECT></TD>\n";
print "</TR>\n";

print "<TR>\n";

print "<TD><B>Screen size 80x43 (font 8x14):</B></TD>\n";
print "<TD><SELECT NAME=\"font14\">\n";

for ($Counter8x14 = 0; $Counter8x14 < $Size8x14; $Counter8x14++) {

  if (@{$Array8x14}[$Counter8x14] eq "NO") {

    if ($vars{'font8x14'} =~ /NO/) {
      print "<OPTION VALUE=\"NO\" SELECTED>No 8x14 font\n";
    } else {
	print "<OPTION VALUE=\"NO\">No 8x14 font\n";
      }
  } elsif (@{$Array8x14}[$Counter8x14] eq "cp437-8x14") { 

      if ($vars{'font8x14'} =~ /cp437-8x14/) {
	print "<OPTION VALUE=\"cp437-8x14\" SELECTED>Codepage 437 English\n";
      } else {
	  print "<OPTION VALUE=\"cp437-8x14\">Codepage 437 English\n";
        }
  } elsif (@{$Array8x14}[$Counter8x14] eq "cp850-8x14") { 

      if ($vars{'font8x14'} =~ /cp850-8x14/) {
	print "<OPTION VALUE=\"cp850-8x14\" SELECTED>Codepage 850 Multilingual Latin I\n";
      } else {
	  print "<OPTION VALUE=\"cp850-8x14\">Codepage 850 Multilingual Latin I\n";
        }
  } elsif (@{$Array8x14}[$Counter8x14] eq "cp865-8x14") { 

      if ($vars{'font8x14'} =~ /cp865-8x14/) {
	print "<OPTION VALUE=\"cp865-8x14\" SELECTED>Codepage 865 Norwegian\n";
      } else {
	  print "<OPTION VALUE=\"cp865-8x14\">Codepage 865 Norwegian\n";
        }
  } elsif (@{$Array8x14}[$Counter8x14] eq "cp866-8x14") { 

      if ($vars{'font8x14'} =~ /cp866-8x14/) {
	print "<OPTION VALUE=\"cp866-8x14\" SELECTED>Codepage 866 Russian\n";
      } else {
	  print "<OPTION VALUE=\"cp866-8x14\">Codepage 866 Russian\n";
        }
  } elsif (@{$Array8x14}[$Counter8x14] eq "iso-8x14") { 

      if ($vars{'font8x14'} =~ /iso-8x14/) {
	print "<OPTION VALUE=\"iso-8x14\" SELECTED>ISO-8859-1 West European\n";
      } else {
	  print "<OPTION VALUE=\"iso-8x14\">ISO-8859-1 West European\n";
        }
  } elsif (@{$Array8x14}[$Counter8x14] eq "koi8-r-8x14") { 

      if ($vars{'font8x14'} =~ /koi8-r-8x14/) {
	print "<OPTION VALUE=\"koi8-r-8x14\" SELECTED>Russian koi8-r\n";
      } else {
	  print "<OPTION VALUE=\"koi8-r-8x14\">Russian koi8-r\n";
        }
  } else {

      if ($vars{'font8x14'} eq @{$Array8x14}[$Counter8x14]) {
	print "<OPTION VALUE=@{$Array8x14}[$Counter8x14] SELECTED>Unknown 8x14 font @{$Array8x14}[$Counter8x14]\n";
      } else {
	  print "<OPTION VALUE=@{$Array8x14}[$Counter8x14]>Unknown 8x14 font @{$Array8x14}[$Counter8x14]\n";
        }
  }
}

print "</SELECT></TD>\n";
print "</TR>\n";

print "<TR>\n";

print "<TD><B>Screen size 80x25 (font 8x16):</B></TD>\n";
print "<TD><SELECT NAME=\"font16\">\n";

for ($Counter8x16 = 0; $Counter8x16 < $Size8x16; $Counter8x16++) {

  if (@{$Array8x16}[$Counter8x16] eq "NO") {

    if ($vars{'font8x16'} =~ /NO/) {
      print "<OPTION VALUE=\"NO\" SELECTED>No 8x16 font\n";
    } else {
	print "<OPTION VALUE=\"NO\">No 8x16 font\n";
      }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp437-8x16") {

      if ($vars{'font8x16'} =~ /cp437-8x16/) {
	print "<OPTION VALUE=\"cp437-8x16\" SELECTED>Codepage 437 English\n";
      } else {
	  print "<OPTION VALUE=\"cp437-8x16\">Codepage 437 English\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp437-thin-8x16") {

      if ($vars{'font8x16'} =~ /cp437-thin-8x16/) {
	print "<OPTION VALUE=\"cp437-thin-8x16\" SELECTED>Codepage 437 English (thin)\n";
      } else {
	  print "<OPTION VALUE=\"cp437-thin-8x16\">Codepage 437 English (thin)\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp850-8x16") {

      if ($vars{'font8x16'} =~ /cp850-8x16/) {
	print "<OPTION VALUE=\"cp850-8x16\" SELECTED>Codepage 850 Multilingual Latin I\n";
      } else {
	  print "<OPTION VALUE=\"cp850-8x16\">Codepage 850 Multilingual Latin I\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp850-thin-8x16") {

      if ($vars{'font8x16'} =~ /cp850-thin-8x16/) {
	print "<OPTION VALUE=\"cp850-thin-8x16\" SELECTED>Codepage 850 Multilingual Latin I (thin)\n";
      } else {
	  print "<OPTION VALUE=\"cp850-thin-8x16\">Codepage 850 Multilingual Latin I (thin)\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp865-8x16") {

      if ($vars{'font8x16'} =~ /cp865-8x16/) {
	  print "<OPTION VALUE=\"cp865-8x16\" SELECTED>Codepage 865 Norwegian\n";
      } else {
	  print "<OPTION VALUE=\"cp865-8x16\">Codepage 865 Norwegian\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp865-thin-8x16") {

      if ($vars{'font8x16'} =~ /cp865-thin-8x16/) {
	print "<OPTION VALUE=\"cp865-thin-8x16\" SELECTED>Codepage 865 Norwegian (thin)\n";
      } else {
	  print "<OPTION VALUE=\"cp865-thin-8x16\">Codepage 865 Norwegian (thin)\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp866-8x16") {

      if ($vars{'font8x16'} =~ /cp866-8x16/) {
	print "<OPTION VALUE=\"cp866-8x16\" SELECTED>Codepage 866 Russian\n";
      } else {
	  print "<OPTION VALUE=\"cp866-8x16\">Codepage 866 Russian\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp866b-8x16") {

      if ($vars{'font8x16'} =~ /cp866b-8x16/) {
	print "<OPTION VALUE=\"cp866b-8x16\" SELECTED>Codepage 866b Russian\n";
      } else {
	  print "<OPTION VALUE=\"cp866b-8x16\">Codepage 866b Russian\n"; 
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "cp866c-8x16") {

      if ($vars{'font8x16'} =~ /cp866c-8x16/) {
	print "<OPTION VALUE=\"cp866c-8x16\" SELECTED>Codepage 866c Russian\n";
      } else {
	  print "<OPTION VALUE=\"cp866c-8x16\">Codepage 866c Russian\n";
        }

  } elsif (@{$Array8x16}[$Counter8x16] eq "iso-8x16") {

      if ($vars{'font8x16'} =~ /iso-8x16/) {
	print "<OPTION VALUE=\"iso-8x16\" SELECTED>ISO-8859-1 West European\n";
      } else {
	  print "<OPTION VALUE=\"iso-8x16\">ISO-8859-1 West European\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "iso-thin-8x16") {
 
      if ($vars{'font8x16'} =~ /iso-thin-8x16/) {
	print "<OPTION VALUE=\"iso-thin-8x16\" SELECTED>ISO-8859-1 West European (thin)\n";
      } else {
	  print "<OPTION VALUE=\"iso-thin-8x16\">ISO-8859-1 West European (thin)\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "koi8-r-8x16") {

      if ($vars{'font8x16'} =~ /koi8-r-8x16/) {
	print "<OPTION VALUE=\"koi8-r-8x16\" SELECTED>Russian koi8-r\n";
      } else {
	  print "<OPTION VALUE=\"koi8-r-8x16\">Russian koi8-r\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "koi8-rb-8x16") {
 
      if ($vars{'font8x16'} =~ /koi8-rb-8x16/) {
	print "<OPTION VALUE=\"koi8-rb-8x16\" SELECTED>Russian koi8-rb\n";
      } else {
	  print "<OPTION VALUE=\"koi8-rb-8x16\">Russian koi8-rb\n";
        }
  } elsif (@{$Array8x16}[$Counter8x16] eq "koi8-rc-8x16") {

      if ($vars{'font8x16'} =~ /koi8-rc-8x16/) {
	print "<OPTION VALUE=\"koi8-rc-8x16\" SELECTED>Russian koi8-rc\n";
      } else {
	  print "<OPTION VALUE=\"koi8-rc-8x16\">Russian koi8-rc\n";
        }
  } else {

      if ($vars{'font8x16'} eq @{$Array8x16}[$Counter8x16]) {
	print "<OPTION VALUE=@{$Array8x16}[$Counter8x16] SELECTED>Unknown 8x16 font @{$Array8x16}[$Counter8x16]\n";
      } else {
	  print "<OPTION VALUE=@{$Array8x16}[$Counter8x16]>Unknown 8x16 font @{$Array8x16}[$Counter8x16]\n";
        }
  }
}

print "</SELECT></TD>\n";

print "</TR>\n";

print "</TABLE></CENTER>\n";

print "<P><INPUT TYPE=\"SUBMIT\" VALUE=\"OK\">\n";
print "<INPUT TYPE=\"RESET\">\n";

print "</FORM>\n";

#
# End HTML form
#

print $form->end_html;

# fonts.pl
