#!/usr/local/bin/perl
#
# Change the keyboard settings file for FreeBSB

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;


$form = new CGI;


#
# get vars from /etc/rc.conf
#

%vars = ();
(%vars) = rcconf_get_some_vars('cursor','keymap','keyrate','keychange');

%FunctionKeys = split(/\s+/, $vars{'keychange'});

#
# Obtain all keymaps
#
my @AllKeyMapsArray = </usr/share/syscons/keymaps/*.kbd>;
foreach (@AllKeyMapsArray) { s/.*\///; s/\.kbd$//; }
sort @AllKeyMapsArray;

#
# Print form header
#

print $form->header;
print $form->start_html(
   -title=>'Change keyboard options',
   -BGCOLOR=>'white');

#
# HTML body
#

print "<FORM METHOD=\"GET\" ACTION=\"http:changekeyboard.pl\">\n";

#
# Heading
#

print "<P>Change various FreeBSD console keyboard settings.\n";
print "Note: these settings have no effect under X Window.</P>\n";

print "<CENTER>\n";

#cursor type
print "<H3>Cursor type</H3>\n";

print "<TABLE>\n";
print "<TR><TD>";

print '<input type=radio name=cursor VALUE="NO"', 
    ($vars{'cursor'} eq "NO") ? 'checked' : '', 
    ">Default ";

print '<input type=radio name=cursor VALUE="normal"', 
    ($vars{'cursor'} eq "normal") ? 'checked' : '', 
    ">Normal ";

print '<input type=radio name=cursor VALUE="blink"', 
    ($vars{'cursor'} eq "blink") ? 'checked' : '', 
    ">Blinking ";

print '<input type=radio name=cursor VALUE="destructive"', 
    ($vars{'cursor'} eq "destructive") ? 'checked' : '', 
    ">Destructive ";

print "</TD></TR>\n";
print "</TABLE>\n";

#keyboard repeat speed
print "<H3>Keyboard repeat speed</H3>\n";
print "<TABLE>\n";
print "<TR><TD>";

print '<input type=radio name=keyrate VALUE="NO"', 
    ($vars{'keyrate'} eq "NO") ? 'checked' : '', 
    ">Default  ";

print '<input type=radio name=keyrate VALUE="normal"', 
    ($vars{'keyrate'} eq "normal") ? 'checked' : '', 
    ">Normal   ";

print '<input type=radio name=keyrate VALUE="slow"', 
    ($vars{'keyrate'} eq "slow") ? 'checked' : '', 
    ">Slow   ";

print '<input type=radio name=keyrate VALUE="fast"', 
    ($vars{'keyrate'} eq "fast") ? 'checked' : '', 
    ">Fast   ";

print "</TD></TR>\n";
print "</TABLE>\n";

print "<P>Set the speed at which keys repeat when held down.";

print "<HR SIZE=\"2\">\n";

#keyboard map
print "<H3>Select a keyboard map</H3>\n";

print "<P><SELECT NAME =\"keymap\" SIZE=\"9\">\n";

print "<OPTION VALUE=\"NO\" ", 
    ($vars{'keymap'} eq 'NO') ? 'SELECTED' : '',
    ">No keyboard map\n";

foreach (@AllKeyMapsArray) {
    if ($_ eq "be.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Belgian ISO-8859-1\n"; }
    elsif ($_ eq "br275.cp850") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Brazilian 275 keyboard Codepage 850\n"; }
    elsif ($_ eq "br275.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Brazilian 275 keyboard ISO-8859-1\n"; }
    elsif ($_ eq "danish.cp865") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Danish Codepage 865\n"; }
    elsif ($_ eq "danish.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Danish ISO-8859-1\n"; }
    elsif ($_ eq "fr.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">French ISO-8859-1\n"; }
    elsif ($_ eq "german.cp850") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">German Codepage 850\n"; }
    elsif ($_ eq "german.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">German ISO-8859-1\n"; }
    elsif ($_ eq "it.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Italian ISO-8859-1\n"; }
    elsif ($_ eq "jp.106") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Japanese 106\n"; }
    elsif ($_ eq "jp.106x") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Japanese 106x (capslock and control swapped)\n"; }
    elsif ($_ eq "norwegian.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Norwegian ISO keymap\n"; }
    elsif ($_ eq "ru.cp866") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Russian Codepage 866 (alternative)\n"; }
    elsif ($_ eq "ru.koi8-r.shift") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Russian koi8-r (shift)\n"; }
    elsif ($_ eq "ru.koi8-r") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Russian koi8-r\n"; }
    elsif ($_ eq "spanish.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Spanish ISO-8859-1\n"; }
    elsif ($_ eq "swedish.cp850") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Swedish Codepage 850\n"; }
    elsif ($_ eq "swedish.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Swedish ISO-8859-1\n"; }
    elsif ($_ eq "swissgerman.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Swiss German ISO keymap\n"; }
    elsif ($_ eq "uk.cp850") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">United Kingdom Codepage 850\n"; }
    elsif ($_ eq "uk.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">United Kingdom ISO-8859-1\n"; }
    elsif ($_ eq "us.iso") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">United States of America ISO-8859-1\n"; }
    elsif ($_ eq "us.dvorak") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">United States of America dvorak\n"; }
    elsif ($_ eq "us.dvorakx") {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">United States of America dvorakx\n"; }
    else {
	print "<OPTION VALUE=\"$_\" ", 
	($vars{'keymap'} eq $_) ? 'SELECTED' : '',
	">Unknown keymap $_\n"; }

}


print "</SELECT>";

print "</CENTER>\n";

print "<P>The default system console driver for FreeBSD (syscons) defaults\n";
print "to a standard \"American\" keyboard map. Users in other countries\n";
print "(or with different keyboard preferences) may wish to choose one of\n";
print "the other keymaps.\n";

print "<HR SIZE=\"2\">\n";

print "<H3>Reprogram function keys</H3>\n";
print "<P>If you want to reprogram your function keys, enter \n";
print "a string for that specific function key. The maximum number ";
print "of characters that can be entered per function key is 16.</P>\n";
print "<CENTER>";

print "<TABLE><tr>\n";

for $FunctionKey (1 .. 12) {

    print "<TD>F$FunctionKey</TD>";
    print "<TD><INPUT TYPE=\"TEXT\" NAME=\"F$FunctionKey\" maxlength=16";
    if (exists($FunctionKeys{$FunctionKey})) {
	print " value=\"$FunctionKeys{$FunctionKey}\"";
    }
    print "></TD>\n";

    if (($FunctionKey % 2) == 0) {	
	print "</tr>\n";
	if ($FunctionKey != 12) {
	    print "<tr>\n";
	}
    }

}

print "</TABLE>\n";

print "<HR SIZE=\"2\">\n";

print "<H3>Other options</H3>\n";
print "<TABLE>\n";

print "<TR><TD>\n";
print "<INPUT TYPE=\"CHECKBOX\" NAME=\"bsdel\"> Swap backspace and delete ";
print "key.\n";
print "</TD></TR><TR><TD>\n";
print "<INPUT TYPE=\"CHECKBOX\" NAME=\"cllct\"> Swap caps lock and left ";
print "control key.</TD></TR>\n";

print "</TABLE></CENTER>\n";

print "<P><INPUT TYPE=\"SUBMIT\" VALUE=\"OK\">\n";
print "<INPUT TYPE=\"RESET\">\n";

print "</FORM>\n";

#
# End HTML form
#

print $form->end_html;

# keyboard.pl








