#!/usr/local/bin/perl
#
# Change the text console's screen map file

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_rcconf;
use returnscrnmapname;


$form = new CGI;


#
# get current scrnmap from /etc/rc.conf
#

%vars = ();
(%vars) = rcconf_get_some_vars('scrnmap');

($Size, @AllScreenMapArray) = return_screenmap_name;

#
# Print form header
#

print $form->header;

print $form->start_html(
   -title=>'System console screenmap',
   -BGCOLOR=>'white');

#
# HTML body
#

print "<FORM METHOD=\"GET\" ACTION=\"http:changescrnmap.pl\">\n";

#
# Heading
#

print "<P>Unless you load a specific font, most PC hardware defaults to\n";
print "displaying characters in the IBM 437 character set.  However,\n";
print "in the Unix world, this character set is very rarely used.  Most\n";
print "Western European countries, for example, prefer ISO 8859-1.\n";
print "<P>American users won't notice the difference since the bottom half\n";
print "of all these character sets is ANSI anyway.\n";
print "If your hardware is capable of downloading a new display font,\n";
print "you should probably choose <A HREF=http:fonts.pl>that option</A>. However, for hardware\n";
print "where this is not possible (e.g. monochrome adapters), a screen\n";
print "map will give you the best approximation that your hardware can\n";
print "display at all.";


print "<CENTER>\n";

print "<H3>Select the screenmap you would like to use:</H3>\n";

print "<SELECT NAME=\"scrnmap\">\n";

for ($ArrayCounter = 0; $ArrayCounter < $Size; $ArrayCounter++) {

   if ($AllScreenMapArray[$ArrayCounter] =~ /NO/) {

     if ($vars{'scrnmap'} =~ /NO/) {

       print "<OPTION VALUE=\"NO\" SELECTED>No screenmap, use default font\n";
     } else {

         print "<OPTION VALUE=\"NO\">No screenmap, use default font\n";
       }
   } elsif ($AllScreenMapArray[$ArrayCounter] =~ /iso-8859-1_to_cp437/) {

       if ($vars{'scrnmap'} =~ /iso-8859-1_to_cp437/) {

	   print "<OPTION VALUE=\"iso-8859-1_to_cp437\" SELECTED>W-Europe ISO";
	   print " 8859 to IBM 437 screenmap\n";
       } else {

            print "<OPTION VALUE=\"iso-8859-1_to_cp437\">W-Europe ISO 8859 ";
	    print "to IBM 437 screenmap\n";
         }
     } elsif ($AllScreenMapArray[$ArrayCounter] =~ /koi8-r2cp866/) {

	 if ($vars{'scrnmap'} =~ /koi8-r2cp866/) {

	   print "<OPTION VALUE=\"koi8-r2cp866\" SELECTED>Russian koi8-r to ";
           print "IBM 866 screenmap\n";
         } else {

              print "<OPTION VALUE=\"koi8-r2cp866\">Russian koi8-r to ";
              print "IBM 866 screenmap\n";
           }
       } else {

	   if ($vars{'scrnmap'} eq $AllScreenMapArray[$ArrayCounter]) {

	     print "<OPTION VALUE=$AllScreenMapArray[$ArrayCounter] SELECTED>";
	     print "nonstandard screenmap $AllScreenMapArray[$ArrayCounter]\n";
	   } else {

	       print "<OPTION VALUE=$AllScreenMapArray[$ArrayCounter]>";
               print "nonstandard screenmap $AllScreenMapArray[$ArrayCounter]\n";
	     }
         }
}

print "</SELECT></CENTER>\n";

print "<P><INPUT TYPE=\"SUBMIT\" VALUE=\"OK\">\n";
print "<INPUT TYPE=\"RESET\">\n";

print "</FORM>\n";

#
# End HTML form
#

print $form->end_html;

# scrnmap.pl
