#!/usr/local/bin/perl
#
# Change the date and the time file for FreeBSB
# (C) 1997 by Wouter de Boer
#
# Usage:
#    date-time.pl
#

#
# CGI script for date-time.pl
#

use Cwd;
use Sys::Hostname;

use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use returnsysconfigsettings;
use readdirentry;

$form = new CGI;

#
# Set variables for this progam
#

$HostName = hostname();
@Months = ("January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");
@Week = ("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
$IconRow = 6;

#
# Set the directory which should be opened
#

$PathName = cwd();

#
# Read the *.cap files from the $PathName
#

@AllEntries = read_dir_entry $PathName;

#
# Obtain Size of EntryArray
#

$Size = scalar @AllEntries;

#
# Because there are three lines for one description,
# divide the $Size by three
#

$Size /= 3;

#
# Calculate how many rows
#

$Rows = (int($Size / $IconRow) + 1);

$ImageCounter = 0;
$CommentCounter = 0;

#
# If $Size <= $IconRow (One or Six *.cap files) 
#

if ($Size <= $IconRow) {

  $IconRow = $Size;
  $Rows = 1;
}

#
# Obtain the local time
#

($sec, $min, $hour, $dom, $mon, $year, $wday, $yday, $isdst) = localtime(time);

#
# Convert year data to normal value
#

$year += 1900;

#
# Obtain needed /etc/sysconfig settings
#

($KeyRate, $KeyMap, $Cursor, $ScreenSaver, $BlankTime, $NTPDate, $Host, $XNTPD, @Card) = return_sysconfig_settings;

#
# Print form header
#

print $form->header;

print $form->start_html(
   -title=>'Change the Date/Time',
   -BGCOLOR=>'white');

#print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"1; URL=date-time.pl\">\n";

#
# HTML body
#

print "<FORM METHOD=\"GET\" ACTION=\"http://$HostName/FreEasy/Date-Time/changedate.pl\">\n";

#
# Heading
#

print "If you want to set the timezone for this system, click on the \n";
print "timezone icon below. If you want to synchronize the time of this \n";
print "system with another systems, click on the synchronize time icon ";
print "below.\n";

print "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=30>\n";

for ($RowCounter = 0; $RowCounter < $Rows; $RowCounter++) {

  print "<TR>\n";

  for ($Counter = 0; $Counter < $IconRow; $ImageCounter++, $Counter++) {

    print "<TD VALIGN=TOP><CENTER>$AllEntries[$ImageCounter]\n";
    print "$AllEntries[++$ImageCounter]</CENTER></TD>\n";
    $ImageCounter++;
  }

  print "</TR>\n";
  print "<TR>\n";

  for ($Counter = 0; $Counter < $IconRow; $Counter++, $CommentCounter++) {
 
    print "<TD><CENTER>$AllEntries[$CommentCounter]\n";
    $CommentCounter += 2;
    print "$AllEntries[$CommentCounter]</CENTER></TD>\n";
  }

  print "</TR>\n";
}

print "</TABLE>\n";

print "<HR SIZE=\"2\">\n";

printf ("<H3>Current local time is: %2.2d:%2.2d:%2.2d</H3>", $hour, $min, $sec);
print "<H3>Enter the new time : ";
print "<INPUT SIZE=\"2\" NAME=\"hour\" MAXLENGTH=\"2\"> : ";
print "<INPUT SIZE=\"2\" NAME=\"min\" MAXLENGTH=\"2\"> : ";
print "<INPUT SIZE=\"2\" NAME=\"sec\" MAXLENGTH=\"2\"></H3>\n";
print "<P>Type your new time as HH:MM:SS\n";
printf ("<H3>Current local date is: %s, %d %s %d</H3>", $Week[$wday], $dom, $Months[$mon], $year);
print "<H3>Enter the new date : ";
print "<INPUT SIZE=\"4\" NAME=\"year\" VALUE=\"$year\" MAXLENGTH=\"4\"> - ";
print "<INPUT SIZE=\"2\" NAME=\"month\" MAXLENGTH=\"2\"> - ";
print "<INPUT SIZE=\"2\" NAME=\"day\" MAXLENGTH=\"2\">";
print "</H3>\n";
print "<P>Type your new date as YYYY-MM-DD\n";

print "<P><INPUT TYPE=\"SUBMIT\" VALUE=\"OK\">\n";
print "<INPUT TYPE=\"RESET\">\n";
print "</FORM>\n";

#
# End HTML form
#

print $form->end_html;

# date-time.pl
