#!/usr/local/bin/perl
#
# Change properties of a group

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_group;
use access_passwd;


$form = new CGI;

#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


# save changes

%properties = ();
%oldproperties = ();
$group = $form->param('originalname');
$gid = $form->param('originalgid');
$properties{'name'} = $form->param('name');
$properties{'gid'} = $form->param('gid');

#build member list
(@users) = get_all_local_users();
foreach $user (@users) {
    if ($form->param("user$user") eq 'yes') {
	if ($properties{'members'} eq '') { $properties{'members'} = $user; }
	else { $properties{'members'} = "$properties{'members'},$user"; }
    }
}

($modified, $errormsg, %oldproperties) = change_local_group($group, $gid, %properties);


#
# Print form header
#

print $form->header;

if ($modified == 0) {
    print $form->start_html(
      -title=>"Properties of group $properties{'name'} not changed",
      -BGCOLOR=>'white');
}
else {
    if ($errormsg eq '') {
	print $form->start_html(
          -title=>"Properties of group $properties{'name'} changed",
          -BGCOLOR=>'white');
    }
    else {
	print $form->start_html(
          -title=>"Failed to change properties of group $properties{'name'}",
          -BGCOLOR=>'white');	
    }
}

print "<a href=http:groupproperties.pl>Add local group</a> |\n";
print "<a href=http:group.pl>Show local groups</a> |\n";
print "<a href=http:/FreEasy/User/userproperties.pl>Add local user</a> |\n";
print "<a href=http:/FreEasy/cgi-bin/setup.pl?path=Administration&title=Administer+your+System>To admin screen</a> |\n";
print "<a href=http:/FreEasy/cgi-bin/start.pl>To main screen</a>\n";
print "<HR SIZE=\"2\">\n";

if ($errormsg eq '') {

    print "<center><H2>Current properties of group $properties{'name'}</H2></center>\n";

    print "<center><table cols=2 width=\"50%\">\n";
    print "<tr><td>Group name</td><td>$properties{'name'}</td></tr>\n";
    print "<tr><td>gid</td><td>$properties{'gid'}</td></tr>\n"; 
    print "</table>\n";
    if ($properties{'members'} eq $oldproperties{'members'}) {
	print "<p>Membership of this group not changed</p>\n";
    }
    else {
	print "<p>Members added or removed from this group.</p>\n";
    }
    print "</center>";
    print "<p></p>";

}
else {
    print "<center><H2>Failure changing properties of group $group</H2></center>\n";
    print "<p>The error message is: $errormsg</p>\n";
}


print "<CENTER><TABLE>\n";
print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=";
print "Administration&title=Administer+your+System\">\n";
print "<IMG SRC=\"/FreEasy/Icons/adminbutton.gif\" ALT=\"BACK TO ";
print "ADMINISTRATION SCREEN\" BORDER=0></A></TD>\n";

print "</TABLE></CENTER>\n";

#
# End HTML form
#

print $form->end_html;

# changegroup.pl
