#!/usr/local/bin/perl
#
# Show all properties of a group

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use POSIX;

use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_passwd;
use access_group;


$form = new CGI;

$group = $form->param('groupname');
$newgroup = ($group eq '');

if ($newgroup == 0 ) {
    (%properties) = get_local_group_properties($group);
}
else {
    $properties{'gid'} = get_new_local_gid;
}

(@users) = get_all_local_users();


# start html page

print $form->header;
if ($newgroup == 0) {
    print $form->start_html(
      -title=>"Properties of local group $group",
      -BGCOLOR=>'white');
}
else {
   print $form->start_html(
      -title=>"Add a local group",
      -BGCOLOR=>'white');
}

if ($newgroup == 0) {
    print "<a href=http:removegroup.pl?groupname=$group&confirm=yes>Remove this group</a> |\n";
    print "<a href=http:/FreEasy/User/userproperties.pl>Add a user</a> |\n";
    print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=group&apropos=0&sektion=5>Consult group man page</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";
    print "<center><H2>Group $group details</H2></center>\n";
}
else {
    print "<center><H2>New group details</H2></center>\n";
}

print "<form method=get action=http:changegroup.pl>\n";

print "<table cols=3 width=\"80%\">\n";

#group name
print '<tr><td>Group name:</td>';
print "<td><input size=20 name=name value=\"$properties{'name'}\" maxlength=32></td>";
print '<td>Both the group name and group id should be unique across the system (and often across a group of systems) since they control file access.</td>';
print "</tr>\n";

#gid
print "<tr><td>Group ID:</td>";
print "<td><input size=5 name=gid value=\"$properties{'gid'}\" maxlength=5></td>";
print "<td>Group numeric id, a value between 0 and 65535.<td>";
print "</tr>\n";
print "</table>\n";
print "<p></p>\n";

# print all users, checked if they're a member of this group
print "<center><table cellspacing=10>\n";
print "<tr>";
$col = 0;
$maxcols = 5;

foreach $user (@users) {
    print "<td><input type=checkbox name=\"user$user\" value=yes";
    if ($properties{'members'} =~ /$user/) { print ' checked'; }
    print ">$user</td>\n";
    $col++;
    if ($col == $maxcols) {
	print "</tr><tr>\n";
	$col = 0;
    }
}

print "</tr></table></center>\n";

print "<input type=hidden name=originalname VALUE=\"$group\">\n";
print "<input type=hidden name=originalgid VALUE=\"$properties{'gid'}\">\n";

print "<INPUT TYPE=SUBMIT VALUE=\"OK\">\n";
print "<INPUT TYPE=RESET>\n";
print "</FORM>\n";


#
# End HTML form
#

print $form->end_html;

# groupproperties.pl
