#!/usr/local/bin/perl
#
# Add printer file
# (C) 1996 by Wouter de Boer
#
# Usage:
#    addprint.pl
#
# CGI script using CGI.pm module
#

use Sys::Hostname;

use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use returnprintername;
use returnport;
use createspooldirectory;
use createlogfile;
use writepostscriptfile;
use addnewprintertofile;
use removelpdescription;
use verify;

$form = new CGI;

#
# Extract value of all added text and buttons
# The name  must  match the name in the 
# Web page for this input field.
#

#
# The comment statements are not used in this program
# In the future this options will be implemented when
# people want to use filter options for the printer
#

#$CF = $form->param('cf');
#$DF = $form->param('df');
#$GF = $form->param('gf');
#$NF = $form->param('nf');
#$RF = $form->param('rf');
#$TF = $form->param('tf');
#$VF = $form->param('vf');

$Description = $form->param('description');
$Spool = $form->param('spool');
$PS = $form->param('ps');
$Def = $form->param('def');
$Log = $form->param('log');
$Job = $form->param('job');
$Port = $form->param('port');
$Printer = $form->param('printer');
$JobSize = $form->param('jobsize');

#
# Obtain the hostname of machine
# 

$HostName = hostname();

if (length($Description) > 0) {

  #
  # Make normal description
  #

  $Description =~ s/\s/\|/g;
  $Description =~ s/\|\|/\+/g;
  $Description =~ s/\|/ /g;
  $Description =~ s/\+/\|/g;
  $Description =~ s/\|$//;

  #
  # Search if user has typed "lp" in description
  #

  $VerifyLP = verify_lp $Description;

  #
  # Default printer ?? Yes remove all other lp in printcap file
  #

  if (($Def eq "Yes") || ($VerifyLP == 1)) {

    $LP = "lp";
    remove_lp_description $LP;

    if ($VerifyLP == 1) {

      $LP = "";
    }
  }

  #
  # Obtain the short printer definition neccesarry for GhostScript
  #

  $GSName = return_short_printer_name $Printer;

  #
  # Obtain the I/O port
  #

  $IOPort = return_iopath $Port;

  #
  # Create the spool directory if neseccary
  #

  create_spool_directory $Spool;

  #
  # Printer log file ??
  #

  if ($Log eq "Yes") {

    create_log_file $Spool, $GSName;
  }

  #
  # PostScript Emulation ??
  # 

  if ($PS eq "Yes") {

    write_postscript_file $GSName;
  }

  add_new_printer_to_file $Spool, $LP, $IOPort, $Printer, $PS, $GSName, $Log, $Job, $Description, $JobSize;


  #
  # Print form header
  #

  print $form->header;

  print $form->start_html(
     -title=>"New Printer $Printer added",
     -BGCOLOR=>'white');

  #
  # HTML body
  #

  #
  # Heading
  #

  print "<h1>Properties of printer $Printer:</h1>\n";
  print "<p>\n";

  print "<p><h3>Description     : $Description\n";
  print "<p>Spool directory     : $Spool\n";
  if ($PS eq "Yes") {
    print "<p>PostScript emulation.\n";
  } else {
      print "<p>No PostScript emulation.\n";
    }
  if (($Def eq "Yes") || ($VerifyLP == 1)) {
    print "<p>Installed as default printer.\n";
  } else {
      print "<p>No default printer.\n";
    }
  if ($Log eq "Yes") {
    print "<p>Installed error.log file.\n";
  } else {
      print "<p>No error.log file.\n";
    }
  if ($Job eq "No") {
    print "<p>Unlimited print job size.\n";
   } else {

       if ((length($JobSize) > 0) && ($JobSize !~ /\D/)) {

         print "<p>Print job size limited to $JobSize kBytes.\n";
       } else {

	   print "<p>Print job size limited to 1000 kBytes.\n";
         }
     }
  if ($Port eq "lpt0") {
    print "<p>LPT1 (/dev/lpt0) selected.\n";
  } elsif ($Port eq "lpt1") {
      print "<p>LPT2 (/dev/lpt1) selected.\n";
    } elsif ($Port eq "cuaa0") {
	print "<p>COM1 (/dev/cuaa0) selected.\n";
      } elsif ($Port eq "cuaa1") {
	  print "<p>COM2 (/dev/cuaa1) selected.\n";
         } elsif ($Port eq "cuaa2") {
	     print "<p>COM3 (/dev/cuaa2) selected.\n";
           } elsif ($Port eq "cuaa3") {
	       print "<p>COM4 (/dev/cuaa3) selected.\n";
	     }

  print "</h3>\n";

} else {

    #
    # Print form header
    #

    print $form->header;

    print $form->start_html(
       -title=>"No New Printer $Printer added",
       -BGCOLOR=>'white');

    #
    # HTML body
    #

    print "<center><h3>No printer description !!</h3></center>\n";
  }

print "<center><table>\n";

print "<tr><td><a href=\"http://$HostName/FreEasy/cgi-bin/start.pl\">\n";
print "<img src=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></a></td>\n";
print "<td><a href=\"http://$HostName/FreEasy/cgi-bin/setup.pl?path=Setup";
print "&title=Setup+your+System\">\n";
print "<img src=\"/FreEasy/Icons/setupbutton.gif\" ALT=\"BACK TO SETUP ";
print "SCREEN\" BORDER=0></a></td>\n";

print "</table></center>\n";

#
# End HTML form
#

print $form->end_html;

# addprint.pl
