#!/usr/local/bin/perl
#
# Change printer file
# (C) 1996 by Wouter de Boer
#
# Usage:
#    changeprint.pl
#
# CGI script using CGI.pm module
#

use Sys::Hostname;

use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use returnprintersettings;
use returnport;
use removelpdescription;
use returnport;
use createspooldirectory;
use createlogfile;
use writepostscriptfile;
use writechangedprinter;
use returnprintername;
use removefile;
use verify;

$form = new CGI;

#
# Extract value of all added text and buttons
# The name  must  match the name in the 
# Web page for this input field.
#

#
# The comment statements are not used in this program
# In the future this options will be implemented when
# people want to use filter options for the printer
#

#$CF = $form->param('cf');
#$DF = $form->param('df');
#$GF = $form->param('gf');
#$NF = $form->param('nf');
#$RF = $form->param('rf');
#$TF = $form->param('tf');
#$VF = $form->param('vf');

$Description = $form->param('description');
$Spool = $form->param('spool');
$RemoteName = $form->param('remname');
$RemPrinter = $form->param('remprint');
$PS = $form->param('ps');
$Def = $form->param('def');
$Log = $form->param('log');
$Job = $form->param('job');
$Port = $form->param('port');
$Printer = $form->param('printer');
$JobSize = $form->param('jobsize');

#
# Obtain the hostname of the machine
#

$HostName = hostname();

if (length($Description) > 0) {

  #
  # Make normal description
  #

  $Description =~ s/\s/\|/g;
  $Description =~ s/\|\|/\+/g;
  $Description =~ s/\|/ /g;
  $Description =~ s/\+/\|/g;
  $Description =~ s/\|$//;

  #
  # Obtain all orginal printer settigs
  #

  ($OrgDescription, $OrgLP, $OrgIOPort, $OrgSpoolPath, $OrgPS, $OrgLog, $OrgJob, $OrgRemoteName, $OrgRemotePrinter, $OrgInputFilterPath, $OrgLogFilePath) = return_printer_settings $Printer;

  #
  # Change something, because some options are not available
  # when choosing a network printer
  #

  if ((length($RemotePrinter) > 0) || (length($RemPrinter) > 0)) {

    $OrgPS = "";
    $OrgLog = "";
  }

  #
  # Obtain freebsd I/O Port Name
  #

  $OrgIOPort = return_freebsd_ioname $OrgIOPort;

  if ($Job ne "No") {

    $Job = $JobSize;
  }

  if (($Description eq $OrgDescription) && ($OrgLP eq $Def) && ($OrgIOPort eq $Port) && ($OrgSpoolPath eq $Spool) && ($OrgPS eq $PS) && ($OrgLog eq $Log) && ($OrgJob eq $Job) && ($OrgRemoteName eq $RemoteName) && ($OrgRemotePrinter eq $RemPrinter)) {

    #
    # Print form header
    #

    print $form->header;

    print $form->start_html(
         -title=>"Properties $Printer unchanged",
         -BGCOLOR=>'white');

    #
    # HTML body
    #

    #
    # Heading
    #

    print "<H1><CENTER>Properties of $Printer are still the same.";
    print "</CENTER></H1>\n";
  } else {

      #
      # Search if user has typed "lp" in description
      #

      $VerifyLP = verify_lp $Description;

      #
      # Default printer ?? Yes remove all other lp in printcap file
      #

      if (($Def eq "Yes") || ($VerifyLP == 1)) {
	  
	$LP = "lp";
	remove_lp_description $LP;
	  
	if ($VerifyLP == 1) {

	  $LP = "";
	}
      }

      #
      # Obtain the short printer definition neccesarry for GhostScript
      #

      $GSName = return_short_printer_name $Printer;

      #
      # Obtain the I/O port
      #

      $IOPort = return_iopath $Port;

      #
      # Create the spool directory if neseccary
      #

      create_spool_directory $Spool;

      #
      # Printer log file ?? Yes, create and No, remove
      #

      if ($Log eq "Yes") {

	create_log_file $Spool, $GSName;
      } else {

	  remove_file $OrgLogFilePath;
        }

      #
      # PostScript Emulation ??
      # 

      if ($PS eq "Yes") {

        write_postscript_file $GSName;
      } else {

	  remove_file $OrgInputFilterPath;
        } 
    
      #
      # Write changed printer settings
      #

      write_changed_printer_settings $Spool, $LP, $Job, $Description, $PS, $Log, $Printer, $IOPort, $GSName, $JobSize, $RemoteName, $RemPrinter;

      #
      # Print form header
      #

      print $form->header;

      print $form->start_html(
         -title=>"Properties $Printer changed",
         -BGCOLOR=>'white');

      #
      # HTML body
      #

      #
      # Heading
      #

      print "<h1>Properties of printer $Printer are changed.</h1>\n";
      print "<p>\n";
      print "<p><h1>The new properties are:</h1>\n";

      if ($Description eq $OrgDescription) {
        print "<h3>Description $Printer unchanged.</h3>\n";
      } else {
	  print "<h3>Description $OrgDescription is now $Description.</h3>\n";
        }
      if ($Spool eq $OrgSpoolPath) {
	print "<h3>Spool directory $Printer unchanged.</h3>\n";
      } else {
          print "<h3>Spool directory $Printer is now $Spool.</h3>\n";
        }

      if ((length($RemoteName) > 0) && (length($RemotePrinter) > 0)) {

        if ($RemoteName eq $OrgRemoteName) {
          print "<h3>Remote machine name $Printer unchanged.</h3>\n";
        } else {
	    print "<h3>Remote machine name $Printer is now $RemoteName.";
	    print "</h3>\n";
          }
        if ($RemPrinter eq $OrgRemotePrinter) {
          print "<h3>Remote printer name $Printer unchanged.</h3>\n";
         } else {
	     print "<h3>Remote printer name $Printer is now $RemPrinter.";
	     print "</h3>\n";
           }
      }

      if ((length($RemoteName) == 0) &&(length($RemotePrinter) == 0)) {

        if ($PS eq "Yes") {
	  print "<h3>PostScript emulation.</h3>\n";
        } else {
	    print "<h3>No PostScript emulation.</h3>\n";
          }
        if ($Log eq "Yes") {
	  print "<h3>Installed error.log file.</h3>\n";
        } else {
	    print "<h3>No error.log file.</h3>\n";
          }
        if ($Port eq "lpt0") {
	  print "<h3>LPT1 (/dev/lpt0) selected.</h3>\n";
        } elsif ($Port eq "lpt1") {
	    print "<h3>LPT2 (/dev/lpt1) selected.</h3>\n";
          } elsif ($Port eq "cuaa0") {
	      print "<h3>COM1 (/dev/cuaa0) selected.</h3>\n";
            } elsif ($Port eq "cuaa1") {
		print "<h3>COM2 (/dev/cuaa1) selected.</h3>\n";
              } elsif ($Port eq "cuaa2") {
		  print "<h3>COM3 (/dev/cuaa2) selected.</h3>\n";
                } elsif ($Port eq "cuaa3") {
		    print "<h3>COM4 (/dev/cuaa3) selected.</h3>\n";
                  }
      }

      if (($Def eq "Yes") || ($VerifyLP == 1)) {
	print "<h3>Installed as default printer.</h3>\n";
      } else {
	  print "<h3>No default printer</h3>\n";
        }

      if ($Job eq "No") {
	print "<h3>Unlimited print job size.</h3>\n";
      } else {
	  if ((length($JobSize) > 0) && ($JobSize !~ /\D/)) {

            print "<h3>Print job size limited to $JobSize kBytes.</h3>\n";
          } else {

	      print "<h3>Print job size limited to 1000 kBytes.</h3>\n";
            }
        }
    }
} else {

    #
    # Print form header
    #

    print $form->header;

    print $form->start_html(
         -title=>"Properties $Printer unchanged",
         -BGCOLOR=>'white');

    #
    # HTML body
    #

    #
    # Heading
    #

    print "<center><h3>No printer description !!</h3></center>\n";
  }
    
print "<center><table>\n";

print "<tr><td><a href=\"http://$HostName/FreEasy/cgi-bin/start.pl\">\n";
print "<img src=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></a></td>\n";
print "<td><a href=\"http://$HostName/FreEasy/cgi-bin/setup.pl?path=Setup";
print "&title=Setup+your+System\">\n";
print "<img src=\"/FreEasy/Icons/setupbutton.gif\" ALT=\"BACK TO SETUP ";
print "BUTTON\" BORDER=0></a></td>\n";

print "</table></center>\n";

#
# End HTML form
#

print $form->end_html;

# changeprint.pl
