#!/usr/local/bin/perl
#
# Add a network printer to printcap file
# (C) 1997 by Wouter de Boer
#
# Usage:
#    networkprint.pl
#
# CGI script using CGI.pm module
#

use Sys::Hostname;

use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use createspooldirectory;
use addnetworkprintertofile;
use removelpdescription;
use verify;

$form = new CGI;

#
# Extract value of all added text and buttons
# The name  must  match the name in the 
# Web page for this input field.
#

$Description = $form->param('description');
$Spool = $form->param('spool');
$RemoteName = $form->param('rsystem');
$RemotePrinter = $form->param('rprinter');
$Def = $form->param('def');
$Job = $form->param('job');
$JobSize = $form->param('jobsize');

#
# Obtain the machine hostname
#

$HostName = hostname();

if ((length($RemoteName) > 0) && (length($RemotePrinter) > 0) && (length($Description) > 0)) {

  #
  # Search if user has typed "lp" in description
  #

  $VerifyLP = verify_lp $Description;

  #
  # Default printer ?? Yes remove all other lp in printcap file
  #

  if (($Def eq "Yes") || ($VerifyLP == 1)) {

    $LP = "lp";
    remove_lp_description $LP;

    if ($VerifyLP == 1) {

      $LP = "";
    }
  }

  #
  # Look if spool directory is equal to "/var/spool/lpd". If yes, place
  # remote system name to the end
  #

  if ($Spool eq "/var/spool/lpd/") {

    $Spool .= "$RemoteName";
  }

  #
  # Create the spool directory if neseccary
  #

  create_spool_directory $Spool;

  #
  # Print form header
  #

  print $form->header;

  print $form->start_html(
       -title=>'Network Printer Added',
       -BGCOLOR=>'white');

  #
  # HTML body
  #

  #
  # Heading
  #



  add_network_printer_to_file $Spool, $LP, $Job, $Description, $RemoteName, $RemotePrinter, $JobSize; 

  print "<h1>Properties of network printer:</h1>\n";
  print "<p>\n";

  print "<p><h3>Description     : $Description\n";
  print "<p>Spool directory     : $Spool\n";
  print "<p>Remote machine name : $RemoteName\n";
  print "<p>Remote printer name : $RemotePrinter\n";

  if (($Def eq "Yes") || ($VerifyLP == 1)) {
    print "<p>Installed as default printer.\n";
  } else {
    print "<p>No default printer.\n";
  }

  if ($Job eq "No") {
    print "<p>Unlimited print job size.</h3>\n";
  } else {
      print "<p>Limited print job size.</h3>\n";
  }

} else {

    #
    # Print form header
    #

    print $form->header;

    print $form->start_html(
       -title=>'No Network Printer Added',
       -BGCOLOR=>'white');

    #
    # HTML body
    #

    #
    # Heading
    #

    print "<h3>You forgot to type a remote system name and/or remote ";
    print "printer name and/or printer description.</h3>\n";
  }

print "<center><table>\n";

print "<tr><td><a href=\"http://$HostName/FreEasy/cgi-bin/start.pl\">\n";
print "<img src=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></a></td>\n";
print "<td><a href=\"http://$HostName/FreEasy/cgi-bin/setup.pl?path=Setup";
print "&title=Setup+your+System\">\n";
print "<img src=\"/FreEasy/Icons/setupbutton.gif\" ALT=\"BACK TO SETUP ";
print "SCREEN\" BORDER=0></a></td>\n";

print "</table></center>\n";

#
# End HTML form
#

print $form->end_html;

# networkprint.pl
