#!/usr/local/bin/perl
#
# Display all printers
# Created: 1996 by Wouter de Boer

# Copyright (c) 1996,1998
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/src/FreEasy/lib';

use CGI qw(:standard :html3);
use access_printcap;


(%printers) = get_all_printers();

print 
    header,
    start_html(
	       -title=>'Printers', 
	       -bgcolor=>'#ffffff');

$maxcol = 6;
print "<table cellpadding=1 cellspacing=30 cols=$maxcol>\n";
print "<tr>\n";

# the add printer icon
@nextrow = ();
print "<td align=center valign=top><a href=\"http:printerproperties.pl\">\n";
print "<img src=\"/FreEasy/Icons/addprint.gif\" alt=\"Add a printer\" border=0></a></td>";
push(@nextrow, "<td align=center valign=top><p><a href=\"http:printerproperties.pl\">add printer</a></p></td>\n");

# all other icons
$col = 1;
foreach $printer (keys %printers) {
    print "<td align=center valign=top><a href=\"printerproperties.pl?printername=$printer\">\n";
    print "<img src=\"/FreEasy/Icons/printer.gif\" alt=\"Modify $printer\" border=0></a></td>\n";
    if ($printers{$printer}{'longname'} ne '') {
	$longname = " ($printers{$printer}{'longname'})";
    }
    else {
	$longname = '';
    }
    push(@nextrow, "<td align=center valign=top><p><a href=\"http:printerproperties.pl?printername=$printer\">$printer$longname</a></p></td>\n");
    $col++;
    if ($col == $maxcol) {
	$col = 0;
	print "</tr>\n";
	print Tr(@nextrow);
	@nextrow = ();
	print "<tr>\n";
    }
}

print "</tr>\n";
if (scalar(@nextrow) > 0) {
    print Tr(@nextrow);
}
print "</table>\n";

print end_html;

# printer.pl

