#!/usr/local/bin/perl
#
# Display properties of an existing or new printer
# Created: 1996 by Wouter de Boer

# Copyright (c) 1996,1998
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/src/FreEasy/lib';
use CGI qw(:standard :html);
use access_printcap;


#
# This printer settings can be changed
#

$Printer = param('printername');
$newprinter = ($Printer eq '');

(%printers) = get_all_printers;


print header;


if ($newprinter) {
    print 
	start_html(-title=>"Add a printer",
		   -BGCOLOR=>'white');
}
else {
    print
	start_html(-title=>"Properties of printer $Printer",
		   -BGCOLOR=>'white');
}

#
# HTML body
#

if ($newprinter) {
    print h1({-align=>center}, 
	     '<font color=\"#660000\">New printer details</font>');
}
else {

    print "<a href=http:removeprinter.pl?printername=$Printer&confirm=yes>Remove this user</a> |\n";
    print "<a href=http:/FreEasy/Group/printerproperties.pl>Add printer</a> |\n";
    print "<a href=http://www.Freebsd.org/handbook/printing.html>Consult FreeBSD handbook on printing</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

    print h1({-align=>CENTER}, "<font color=\"#660000\">Printer $Printer details</font>"),
    "\n";


}


print
    start_form('get', 'changeprinter.pl'),
    table({-cols=>3},

#descriptions
	  TR(td({-valign=>top}, 
		['Printer names', 
		 textarea(-name=>'descriptions', -rows=>4, -columns=>20), 
		 'You may give multiple names to a printer. Each line contains an alternate printer name.'])),
	  "\n",



#default printer
	  TR(td({-valign=>top}, 
		['Default printer', 
		 checkbox(-name=>'defaultprinter',-checked=>'checked',-value=>'yes'), 
		 'Check it to make this the default printer. With this option you make sure that one of the names of this printer is lp and that their is no other printer with this name.'])),
	  "\n",
	  ),
    "\n",

#spool directory

    hr({-size=>2}),
    "\n",

#port
    h3({-align=>CENTER}, 'Printer port settings'),
    table({-cols=>3},
	  TR(td({-valign=>top},
		['Port',
		 popup_menu(-name=>'printerprot',
			     -values=>['/dev/lpt0', '/dev/lpt1'],
			     -default=>'/dev/lpt0'),
		 'device name to open for output'])),
	  "\n",
#set interrupt driven or polled here?
#serial port comm params here
	  TR(td({-valign=>top},
		['Serial port baud rate',
		 popup_menu(-name=>'br',
			    -values=>['',50,75,110,134,150,200,300,600,1200,1800,2400,4800,9600,19200,38400],
			    -default=>$printers{$Printer}{'br'}),
		 'Select the baudrate if you have selected a serial port'])),
	  "\n",
	  TR(td({-valign=>top},
		['Serial port clear bits',
		 textfield(-name=>'fc',
			   -size=>8,
			   -maxsize=>8,
			   -value=>$printers{$Printer}{'fc'}),
		 'Clears the flag bits clear-bits in the sgttyb structure after opening the device. I know this help doesn\'t help you much, but maybe some serial printer expert can give me better fields for setting up a serial printer?'])),
	  "\n",
	  TR(td({-valign=>top},
		['Serial port clear bits',
		 textfield(-name=>'fs',
			   -size=>8,
			   -maxsize=>8,
			   -value=>$printers{$Printer}{'fs'}),
		 'Sets the flag bits set-bits in the sgttyb structure.'])),
	  "\n",
	  TR(td({-valign=>top},
		['Serial port clear bits',
		 textfield(-name=>'xc',
			   -size=>8,
			   -maxsize=>8,
			   -value=>$printers{$Printer}{'xc'}),
		 'Clears local mode bits clear-bits after opening the device.'])),
	  "\n",
	  TR(td({-valign=>top},
		['Serial port clear bits',
		 textfield(-name=>'xs',
			   -size=>8,
			   -maxsize=>8,
			   -value=>$printers{$Printer}{'xs'}),
		 'Sets local mode bits set-bits.'])),
	  "\n",

#remote machine name
#remote printer name

#Filters:
#simulate postscript filter
#plain text to post script filter
#smart printer filter

#Other:
#suppress banner
#print banner last
#short banner
#suppress formfeeds
#disable multiple copies
#max print job size
#error log file or /dev/console

#Security:
#restricted group
#restricted remote users to those with local account


       ),
       "\n",
       hidden(-name=>'printername',
	      -value=>"$Printer"),
       submit(-value=>'OK'),
       reset,
       end_form,
       end_html;


# printerproperties.pl
