#!/usr/local/bin/perl
#
# Stop or reboot the system
# (C) 1997 by Wouter de Boer

# Copyright (c) 1998 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI qw(:standard :html3);


# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/bin:/usr/bin";


$form = new CGI;

#
# Extract value of all added text and buttons

($Sec, $Min, $Hour, $lmday, $Month, $Year, $lwday, $lyday, $isdst) = localtime(time);

$Command = $form->param('command');
$Choice = $form->param('choice');
$Minutes = $form->param('minutes');
$Min = $form->param('min');
$Hour = $form->param('hour');
if ($form->param('day') ne '') { $Day = $form->param('day'); }
if ($form->param('month') ne '') { $Month = $form->param('month'); }
if ($form->param('year') ne '') { $Year = $form->param('year'); }
$WarningMsg = $form->param('warningmsg');



print header;

# our topline
$topline = "<a href=\"http:/FreEasy/cgi-bin/start.pl\">To main screen</a><br><img src=\"http:/FreEasy/Icons/bluebar2.gif\">\n";


# what do we want
if ($Command eq "-r") {
    print 
	start_html(
		     -title=>'Reboot System',
		     -BGCOLOR=>'white'),
	$topline,
	h1({-align=>center}, '<font color="#660000">Reboot System</font>');
    $ActionStr = 'reboot';
}
elsif ($Command eq "-h") {
    print 
	start_html(
		     -title=>'Halt System',
		     -BGCOLOR=>'white'),
	$topline,
	h1({-align=>CENTER}, '<font color="#660000">Halt System</font>');
    $ActionStr = 'shutdown';
}
elsif ($Command eq "-k") {
    print 
	start_html(
		     -title=>'Kick off everybody',
		     -BGCOLOR=>'white'),
	$topline,
	h1({-align=>center}, '<font color="#660000">Kick off everyone</font>');
    $ActionStr = 'kick off everbody';
}


#check supplied time
if ($Choice eq "now") {

    #do it now
    print "<p>Action happens now. Hope you still can read this :-)</p>\n";
    system '/sbin/shutdown', "$Command", 'now', "$WarningMsg";

}

elsif ($Choice eq "time") {

    # do it after x minutes
#&& (length($Minutes) > 0) && ($Minutes !~ /\D/)) {
    if ( ($Minutes ne '') && ($Minutes =~ /^\d+$/) ) {
	system '/sbin/shutdown', "$Command", "+$Minutes", "$WarningMsg";
	print "<p>System will $ActionStr after $Minutes minute(s).</p>";
    }
    else {
	print "<p>You didn't specify the number of minutes correctly. Please go Back to the last screen and enter a correct value.</p>";
    }

}
elsif ($Choice eq "date") {

#&& (length($Hour) > 0) && (length($Min) > 0) && (length($Day) > 0) && (length($Month) > 0) && (length($Year) > 0) && ($Hour !~ /\D/) && ($Min !~ /\D/) && ($Day !~ /\D/) && ($Month !~ /\D/) && ($Year !~ /\D/)) 
    # Reboot on a specified period
    if ( ($Year ne '') && ($Year =~ /^\d+$/) &&
	 ($Month ne '') && ($Month =~ /^\d+$/) && 
	 ($Day ne '') && ($Day =~ /^\d+$/) && 
	 ($Hour ne '') && ($Hour =~ /^\d+$/) && 
	 ($Min ne '') && ($Min =~ /^\d+$/) ) {
	if ($Year >= 100) { $Year = $Year % 100; }
	$actiontime = sprintf("%2.2d%2.2d%2.2d%2.2d%2.2d", $Year, $Month, $Day, $Hour, $Min);
	system '/sbin/shutdown', "$Command", "$actiontime", "$WarningMsg";
	printf("<p>System Reboot at %2.2d:%2.2d on %2.2d-%2.2d-%2.2d</H1></p>\n", $Hour, $Min, $Day, $Month, $Year);
    }
    else {
	print "<p>You didn't specify the date correctly. Please go Back to the last screen and enter a correct value.</p>";
    }

}
else {
	print "<p>You didn't specify the time your action should occur. Please go Back to the last screen and enter a correct value.</p>";
}


print "<CENTER><TABLE>\n";

print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=";
print "Administration&title=Administer+your+System\">\n";
print "<IMG SRC=\"/FreEasy/Icons/adminbutton.gif\" ALT=\"BACK TO ";
print "ADMINISTRATION SCREEN\" BORDER=0></A></TD>\n";

print "</TABLE></CENTER>\n";

#
# End HTML form
#

print end_html;

# stop-system.pl
