#!/usr/local/bin/perl
#
# Change properties of an user

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_passwd;
use access_group;


$form = new CGI;

#
# make sure we have a secure path
$ENV{PATH} = "/sbin:/usr/sbin:/usr/bin";


# save changes

%properties = ();
%oldproperties = ();
$user = $form->param('originalname');
$uid = $form->param('originaluid');
$properties{'name'} = $form->param('name');
$properties{'uid'} = $form->param('uid');
$primarygroup = $form->param('pgroup');
$properties{'gid'} = get_local_gid($primarygroup);
$properties{'fullname'} = $form->param('fullname');
$properties{'office'} = $form->param('office');
$properties{'wphone'} = $form->param('wphone');
$properties{'hphone'} = $form->param('hphone');
$properties{'homedir'} = $form->param('homedir');
if ($properties{'homedir'} eq '/home/') {
    $properties{'homedir'} = "$properties{'homedir'}$properties{'name'}";
}
$properties{'shell'} = $form->param('shell');
$properties{'class'} = $form->param('class');
$properties{'change'} = $form->param('change');
$properties{'expire'} = $form->param('expire');
if ( ($form->param('password1') eq $form->param('password2')) &&
     ($form->param('password1') ne '********') ) {
    $properties{'plainpw'} = $form->param('password1');
}

# build list of additional groups
# make sure primary group is excluded
@groups = ();
(@groups) = get_all_local_groups;
$grouplist = '';
foreach $group (@groups) {
    if ( ($form->param("group$group") eq 'yes') &&
	 ($group ne $primarygroup) ){
	if ($grouplist eq '') {	$grouplist = $group; }
	else { $grouplist = "$grouplist,$group"; }
    }
}
$properties{'grouplist'} = $grouplist;

($modified, $errormsg, %oldproperties) = change_local_user($user, $uid, %properties);



#
# Print form header
#

print $form->header;

if ($modified == 0) {
    print $form->start_html(
      -title=>"Properties of user $properties{'name'} not changed",
      -BGCOLOR=>'white');
}
else {
    if ($errormsg eq '') {
	print $form->start_html(
          -title=>"Properties of user $properties{'name'} changed",
          -BGCOLOR=>'white');
    }
    else {
	print $form->start_html(
          -title=>"Failed to change properties of user $properties{'name'}",
          -BGCOLOR=>'white');	
    }
}

print "<a href=http:userproperties.pl>Add local user</a> |\n";
print "<a href=http:user.pl>Show local users</a> |\n";
print "<a href=http:/FreEasy/cgi-bin/setup.pl?path=Administration&title=Administer+your+System>To admin screen</a> |\n";
print "<a href=http:/FreEasy/cgi-bin/start.pl>To main screen</a>\n";
print "<HR SIZE=\"2\">\n";

if ($errormsg eq '') {

    print "<center><H2>Current properties of user $properties{'fullname'}</H2></center>\n";

    (%newproperties) = get_local_user_properties($properties{'name'});

    print "<center><table cols=2 width=\"50%\">\n";
    print "<tr><td>Login name</td><td>$properties{'name'}</td></tr>\n";
    print "<tr><td>Full name</td><td>$properties{'fullname'}</td></tr>\n";
    if ($properties{'plainpw'} ne '') {
	print "<tr><td>Password changed</td><td></td></tr>\n";
    }
    print "<tr><td>UID</td><td>$properties{'uid'}</td></tr>\n";
    print "<tr><td>GID</td><td>$properties{'gid'}</td></tr>\n";
    print "<tr><td>Home directory</td><td>$properties{'homedir'}</td></tr>\n";
    print "<tr><td>Shell</td><td>$properties{'shell'}</td></tr>\n";
    print "<tr><td>Login class</td><td>$properties{'class'}</td></tr>\n";
    print "<tr><td>Password expiration date</td><td>$newproperties{'change'}</td></tr>\n";
    print "<tr><td>Account expiration date</td><td>$newproperties{'expire'}</td></tr>\n";
    print "<tr><td>Office</td><td>$properties{'office'}</td></tr>\n";
    print "<tr><td>Work phone</td><td>$properties{'wphone'}</td></tr>\n";
    print "<tr><td>Home phone</td><td>$properties{'hphone'}</td></tr>\n";
    
    print "</table></center>\n";
    print "<p></p>";

}
else {
    print "<center><H2>Failure changing properties of user $user</H2></center>\n";
    print "<p>The error message is: $errormsg</p>\n";
}

print "<CENTER><TABLE>\n";
print "<TR><TD><A HREF=\"http:/FreEasy/cgi-bin/start.pl\">\n";
print "<IMG SRC=\"/FreEasy/Icons/mainbutton.gif\" ALT=\"BACK TO MAIN ";
print "PROGRAM\" BORDER=0></A></TD>\n";
print "<TD><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=";
print "Administration&title=Administer+your+System\">\n";
print "<IMG SRC=\"/FreEasy/Icons/adminbutton.gif\" ALT=\"BACK TO ";
print "ADMINISTRATION SCREEN\" BORDER=0></A></TD>\n";

print "</TABLE></CENTER>\n";

#
# End HTML form
#

print $form->end_html;

# changeuser.pl
