#!/usr/local/bin/perl
#
# Show properties of a given user
#

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use lib '/usr/home/berend/FreEasy/lib';
use CGI;
use access_passwd;
use access_group;
use access_shells;

$form = new CGI;


# which user are we talking about?
$user = $form->param('username');

$newuser = ($user eq '');

# get all properties of this user
%properties = ();
if ($newuser == 0 ) {
    (%properties) = get_local_user_properties($user);
}
else {
    # should really get these from /etc/pw.conf    
    $properties{'homedir'} = '/home/';
    $properties{'homedir'} = '/home/';
    $properties{'shell'} = '/usr/local/bin/bash';
    $properties{'uid'} = get_new_local_uid;
    $properties{'change'} = 'never';
    $properties{'expire'} = 'never';
}

# get groups
%groups = ();
(%groups) = get_all_local_groups_with_member_info($user);
if ($newuser == 0) {
    $primarygroup = get_local_group_name($properties{'gid'});
}
else {
    $primarygroup = 'nogroup';
}

# get all shells
(@shells) = get_all_shells;


# start html page

print $form->header;
if ($newuser == 0) {
    print $form->start_html(
      -title=>"Properties of local user $user",
      -BGCOLOR=>'white');
}
else {
   print $form->start_html(
      -title=>"Add a local user",
      -BGCOLOR=>'white');
}

print "<FORM METHOD=\"GET\" ACTION=\"http:changeuser.pl\">\n";

if ($newuser == 0) {
    print "<a href=http:removeuser.pl?username=$user&confirm=yes>Remove this user</a> |\n";
    print "<a href=http:/FreEasy/Group/groupproperties.pl>Add local group</a> |\n";
    print "<a href=http://www.de.freebsd.org/de/cgi/man.cgi?query=passwd&apropos=0&sektion=5>Consult passwd man page</a>\n";
    print "<br><img src=http:/FreEasy/Icons/bluebar2.gif>\n";

    print "<center><H2>User $user details</H2></center>\n";
}
else {
    print "<center><H2>New user details</H2></center>\n";
}


print "<table cols=3>\n";

#login name
print '<tr><td>Login name:</td>';
print "<td><input size=8 name=name value=\"$properties{'name'}\" maxlength=8></td>";
print '<td>Login names can be only 8 characters long and only lowercase characters and numbers are allowed.</td>';
print "</tr>\n";

#fullname
print '<tr><td>Full name:</td>';
print "<td><input size=30 name=fullname value=\"$properties{'fullname'}\"</td>";
print "<td>If an ampersand `&' character appears within the fullname field, programs which use this field will substitute it with a capitalized version of the account's login name.</td>";
print "</tr>\n";

#password 1
print '<tr><td>Password:</td>';
print "<td><input size=14 name=password1 value=\"";
if ($newuser == 0) { print "********"; }
print "\" type=password maxlength=14</td>";
print "<td>If you want to change/set the password, type the new password in this box and in the box below. Unusual characters, digits and lower and uppercase characters are suggested. Spaces are not allowed.</td>";
print "</tr>\n";

#password 2
print '<tr><td>Confirm password:</td>';
print "<td><input size=14 name=password2 value=\"";
if ($newuser == 0) { print "********"; }
print "\" type=password maxlength=14</td>";
print "<td>Make sure to enter the same password here.</td>";
print "</tr>\n";

#uid
print "<tr><td>User's ID:</td>";
print "<td><input size=5 name=uid value=\"$properties{'uid'}\" maxlength=5></td>";
print "<td>A user id (uid) is a number between 0 and 65535. Every user should have a unique id. It's very uncommon for two users to have the same uid.<td>";
print "</tr>\n";

#primary group
print "<tr><td>Primary group:</td>";
print "<td><select name=pgroup size=1>\n";
foreach $group (sort keys %groups) {
    print "<option", ($group eq $primarygroup) ? ' selected' : '', ">$group\n";
}
print "</select></td>";
print "<td>A user has to be at least a member of one group, it's primary group. This is that group.<td>";
print "</tr>\n";

#home directory
print '<tr><td>Home directory:</td>';
print "<td><input size=30 name=homedir value=\"$properties{'homedir'}\"</td>";
print "<td>The user's home directory is the full UNIX path name where the user will be placed on login. The home directory is usually /home/ with the user's login name appended. </td>";
print "</tr>\n";

#shell
print '<tr><td>Shell:</td>';
print "<td><select name=shell size=1>\n";
foreach $shell (@shells) {
    print "<option", ($shell eq $properties{'shell'}) ? ' selected' : '', ">$shell\n";
}
print "</select></td>";
print "<td>The command interpreter the user prefers. You can select one of the shells available on this system (according to /etc/shells). The bash shell is a good start for new users if it is available.</td>";
print "</tr>\n";

#login class
print '<tr><td>Login class:</td>';
print "<td><input size=20 name=class value=\"$properties{'class'}\"</td>";
print "</tr>\n";

#password expiration date
print '<tr><td>Password expiration date:</td>';
print "<td><input size=24 name=change value=\"$properties{'change'}\"</td>";
print "<td>Set the account's expiration date.  Format of the date is ";
print "either a UNIX time in decimal, or a date in `dd-mmm-yy[yy]' ";
print "format, where dd is the day, mmm is the month, either in numeric ";
print "or alphabetic format ('Jan', 'Feb', etc) ";
print "and year is either a two or four digit year.  This option ";
print "also accepts a relative date in the form `+n[mhdwoy]' where ";
print "`n' is a decimal, octal (leading 0) or hexadecimal (leading ";
print "0x) digit followed by the number of Minutes, Hours, Days, ";
print "Weeks, Months or Years from the current date at which the ";
print "expiry date is to be set.</td>";
print "</tr>\n";

#account expiration date
print '<tr><td>Account expiration date:</td>';
print "<td><input size=24 name=expire value=\"$properties{'expire'}\"</td>";
print "<td>Set the account's password expiration date. This field is ";
print "identical to the account expiration date option, except ";
print "that it applies to forced password changes. The same formats are ";
print "accepted as with the account expiration option.</td>";
print "</tr>\n";

#office
print '<tr><td>Office:</td>';
print "<td><input size=20 name=office value=\"$properties{'office'}\"</td>";
print "</tr>\n";

#work phone
print '<tr><td>Work phone:</td>';
print "<td><input size=20 name=wphone value=\"$properties{'wphone'}\"</td>";
print "</tr>\n";

#home phone
print '<tr><td>Home phone:</td>';
print "<td><input size=20 name=hphone value=\"$properties{'hphone'}\"</td>";
print "</tr>\n";

print "</table>\n";


print "<HR SIZE=\"2\">\n";


# secondary group membership
print "<center>";
if ($newuser == 0) {
    print "<h3>User $user is also a member of these groups</h3>\n";
    print "<p>Note: group membership changes do not take effect immediately ";
    print "for current logins, only logins subsequent to the change.</p>\n";
}
else {
    print "<h3>New user should also become a member of these groups</h3>\n";
}

print "<table cellspacing=10>\n";
print "<tr>";
$col = 0;
$maxcols = 5;

foreach $group (sort keys %groups) {
    print "<td><input type=checkbox name=\"group$group\" value=yes";
    if ($groups{$group} eq 'YES') { print ' checked'; }
    print ">$group</td>\n";
    $col++;
    if ($col == $maxcols) {
	print "</tr><tr>\n";
	$col = 0;
    }
}

print "</tr></table></center>\n";

print "<input type=hidden name=originalname VALUE=\"$user\">\n";
print "<input type=hidden name=originaluid VALUE=\"$properties{'uid'}\">\n";

print "<INPUT TYPE=\"SUBMIT\" VALUE=\"OK\">\n";
print "<INPUT TYPE=\"RESET\">\n";
print "</FORM>\n";

#
# End HTML form
#

print $form->end_html;

# userproperites.pl
