#!/usr/local/bin/perl
#
# Formats and displays capability (*.cap) files
#
# a .cap file has the following format:
# 1st line: <a href=..> (do not include a </a> line!)
# 2nd line: <img src=..>
# the img goes into its own cell, surrounded by the given link
# 3rd and following lines go into the text/comment cell (below the
# image) also surrounded by the given link
#

#
# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 


use Cwd;

use lib '/usr/src/FreEasy/lib';
use CGI qw(:standard :html3);


#
# Read the *.cap files from the given path
#

$CapDirectoryPath = param('path');
$Title = param('title');

$PathName = cwd();
$PathName =~ s/cgi-bin/$CapDirectoryPath/;

@Caps = <$PathName/*.cap>;
sort @Caps;


#
# start html page
#

print 
    header,
    start_html(
	       -title=>"$Title",
	       -BGCOLOR=>'#ffffff'),
    h1({-align=>center}, "<font color=\"#660000\">$Title</font>"),
    "\n";


# print cap entries
$MaxCols = 5;
print "<table border=0 cellpadding=1 cellspacing=30>\n";
print "<tr>";

@nextrow = ();
$Col = 0;
foreach $cap (@Caps) {

    #read and parse this .cap file
    open (FILE, "$cap");
    $Link = <FILE>;
    chop($Link);
    $Img = <FILE>;
    chop($Img);
    $Caption = '';
    while (<FILE>) {
	chop($_);
	$Caption .= $_;
    }    
    close (FILE);

    #write cell, save text for next row
    print "<td align=center valign=top>";
    print "$Link $Img </a>";
    print "</td>\n";
    push(@nextrow, "<td align=center valign=top><p>$Link $Caption</a></td>\n");

    $Col++;

    # do we need to start the next row?
    if ($Col == $MaxCols) {
	$Col = 0;
	print "</tr>\n";
	print Tr(@nextrow);
	@nextrow = ();
	print "<tr>\n";
    }

}

print "</tr>\n";
print Tr(@nextrow);
print "</table>\n";


#
# End HTML form
#

print end_html;

# setup.pl
