#!/usr/local/bin/perl
#
# start page for FreEasy, shows how many users are logged on,
# and the disk info

# Copyright (c) 1997 
#      Brothers de Boer.  All rights reserved.
#  
# Redistribution and use in source and binary forms, with or without 
# modification, are permitted provided that the following conditions 
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer,
#    verbatim and that no modifications are made prior to this
#    point in the file.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY Brothers de Boer ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL WOUTER DE BOER OR BEREND DE BOER OR ANY
# OTHER OF THEIR BROTHERS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, LIFE 
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 

require 5.002;


use lib '/usr/src/FreEasy/lib';
use CGI;
use information;

$form = new CGI;

#
# Print form header
#

print $form->header;

print $form->start_html(
   -title=>'FreEasy Configuration Program',
   -BGCOLOR=>'white');

print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"60; URL=start.pl\">\n";

#
# HTML body
#

#
# Heading
#

print "<CENTER>\n";

print "<a href=http://www.freebsd.org><IMAGE SRC=\"http:/FreEasy/Icons/freebsd.gif\"";
print " alt=\"FreeBSD turning PCs into Workstations\" border=0></a>\n";

print "<H1 ALIGN=CENTER>FreEasy Configuration Program</H1>\n";

print "<P><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=";
print "Setup&title=Setup+your+System\">Setup</A> </P>\n";
print "<P><A HREF=\"http:/FreEasy/cgi-bin/setup.pl?path=";
print "Administration&title=Administer+your+System\">Administration</A></P>\n";
print "<p><a href=\"http:/FreEasy/cgi-bin/setup.pl?path=";
print "AddRemoveSoftware&title=Add/remove+software\">Add/remove software</a></p>\n";

print "<HR SIZE=\"2\">\n";
print "<H3>Server Statistics:</H3></CENTER>\n";

($Time, $Up, $Users, $Load1, $Load5, $Load15) = sys_info;

print "<PRE>\n";
print "Current time                 : $Time\n";
print "Time system has been up      : $Up\n";
print "Number of users              : $Users\n";
print "Load average last minute     : $Load1\n";
print "Load average last 5 minutes  : $Load5\n";
print "Load average last 15 minutes : $Load15\n";
print "</PRE>\n";

print "<HR SIZE=\"2\">\n";

print "<CENTER><H3>Disk Statistics:</H3></CENTER>\n";

($SizeDisk, $Percent, $Mounted) = disk_info;

print "<TABLE>\n";

for ($ArrayCounter = 1; $ArrayCounter < $SizeDisk; $ArrayCounter++) {

   print "<TR>\n";
   print "<TD>@{$Mounted}[$ArrayCounter]</TD>";
   print "<TD>@{$Percent}[$ArrayCounter] used</TD>";
   $Size = @{$Percent}[$ArrayCounter];
   $Size =~ s/%//;
   print "<TD>";
   for ($Counter = 0; $Counter < $Size; $Counter++) {

        print "<IMG SRC=\"http:/FreEasy/Icons/used.gif\" ";
	print "ALT=\"-\">";
   }
   print "</TD>\n";
   print "</TR>\n";
}

print "</TABLE>\n";

print "<HR SIZE=\"2\">\n";

print "<CENTER><TABLE><TR>\n";
print "<TD><IMAGE SRC=\"http:/FreEasy/Icons/pbfbsd2.gif\" ";
print "ALT=\"powered by FreeBSD\"></TD>\n";
print "<TD><IMAGE SRC=\"http:/FreEasy/Icons/apache.gif\" ";
print "ALT=\"powered by Apache\"></TD>\n";
print "</TR></TABLE>\n";

print "<P>Program made by <a href=\"mailto:wouter.de.boer\@pobox.com\">";
print "Wouter de Boer</a> and <a href=\"mailto:berend\@pobox.com\">Berend de Boer</a>, The Netherlands\n</CENTER>";

#
# End HTML form
#

print $form->end_html;

# start.pl


