#!/usr/local/bin/perl

# only do something on post-install
if ($ARGV[1] ne 'POST-INSTALL') { exit; }

use Cwd;


# installation script for FreEasy

# in which directory are we installed?
$OurDir = $ENV{'PKG_PREFIX'};


# make sure all 'use lib' commands look in the right directory
open (FILE, "- |") or exec "/usr/bin/find", "$OurDir", '(', '-name', '*.pl', '-or', '-name', '*.pm', ')', '-print';
while ($filename = <FILE>) {
    $modified = 0;
    chop($filename);
    open (SCRIPT, $filename);
    $tmpfilename = "$filename.new";
    open (NEWSCRIPT, "> $tmpfilename");
    while (<SCRIPT>) {
	if ($_ =~ /^use lib/) { 
	    $_ = "use lib '$OurDir/lib';\n"; 
	    $modified = 1; 
	}
	print NEWSCRIPT $_;
    }
    close NEWSCRIPT;
    close SCRIPT;

    # if modified, replace the existing file
    if ( $modified ) {
	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
	 $atime,$mtime,$ctime,$blksize,$blocks) = stat $filename;
	unlink $filename or die "can't remove $filename: $!";
	rename($tmpfilename, $filename) or die "can't rename $tmpfilename to $filename: $!";	
	chmod $mode, $filename;
	chown $uid, $gid, $filename;
    }
    else {
	unlink $tmpfilename;
    }
}
close FILE;


# load the access_apache module
require "$OurDir/lib/access_apache.pm";

# add FreEasy Alias and ScriptAlias to apache
$srmconf = access_apache::get_srmconf_location();
if (-e $srmconf) {
  access_apache::add_alias($srmconf, 'FreEasy', "$OurDir/");
}
else {
    warn "Can't update your Apache configuration as $srmconf could not be found. See the README to manually update your apache configuration.\n";
}


# reinit apache if it runs
if (-e '/var/run/httpd.pid') {
    system('kill -1 `cat /var/run/httpd.pid`');
}


# make sure certain scripts set uid root
# normally not necessary as tar should have preserved this setting
#system('setuidroot.sh');
