#!/usr/bin/perl

# no deinstall requirements
if ($ARGV[1] eq 'DEINSTALL') { exit; }


# requirement script: tests 
# 1. if perl5.002 is available,
# 2. if CGI.pm is available,
# 3. if other standard pm's are availabile


$WhereIsPerl5 = '/usr/local/lib/perl5';
$WhereIsCGI = '/usr/local/lib/perl5/CGI.pm';
$WhereIsCWD = '/usr/local/lib/perl5/Cwd.pm';
$WhereIsHostname = '/usr/local/lib/perl5/Sys/Hostname.pm';
$WhereIsFTP1 = '/usr/local/lib/perl5/site_perl/Net/FTP.pm';
$WhereIsFTP2 = '/usr/local/lib/perl5/Net/FTP.pm';
$WhereIsPosix = '/usr/local/lib/perl5/POSIX.pm';
$WhereIsApache = '/usr/local/sbin/httpd';

if (!(-d $WhereIsPerl5)) {
    die "Sorry, need perl5.\n You may install perl5 by executing 'pkg_add ftp://ftp.freebsd.org/pub/FreeBSD/packages-current/lang/perl-5.00404.tgz'\n";
}

if (!(-e $WhereIsCGI)) {
    die "Sorry, need perl module $WhereIsCGI. Get it from http://www.genome.wi.mit.edu/ftp/pub/software/WWW/cgi_docs.html\n";
}

if (!(-e $WhereIsCWD)) {
    die "Sorry, need perl module Cwd.pm.\n";
}

if (!(-e $WhereIsHostname)) {
    die "Sorry, need perl module Sys/Hostname.pm.\n";
}

if (!(-e $WhereIsFTP1) && !(-e $WhereIsFTP2)) {
    warn "You don't seem to have the perl module Net::FTP.pm. You will not be able to use some FreEasy options. See the README how to get this package and how to install it.\n";
}


#if (!(-e $WhereIsPosix)) {
#    die "Sorry, need perl module POSIX.pm.";
#}


if (!(-e $WhereIsApache)) {
    die "Sorry, you need to have the Apache webserver installed (I looked in $WhereIsApache to check if it was installed).\n";
}


#also we need Apach 1.1 or higher
