package addnetworkprintertofile;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(add_network_printer_to_file);

sub add_network_printer_to_file {

#
# add network printer to printcap file
# (C) 1997 by Wouter de Boer
#
# Usage:
#    add_new_printer_to_file arg1, arg2, arg3, arg4, arg5, arg6, arg7
#
#	arg1: Spool Directory
#	arg2: Local printer (yes/no)
#	arg3: Limit Job Size (yes/no)
#	arg4: Otherprinter description
#	arg5: Remote Name
#	arg6: Remote Printer
#	arg7: Job Size
#

#
# Get printer properties
#

my($SpoolPath, $LP, $Job, $Description, $RemoteName, $RemotePrinter, $JobSize) = @_;

#
# Location of printcap file
#

$PrintcapPath = "/etc/printcap";

#
# Open the "/etc/printcap" file for writing, reading or
# create the file if not exists 
#

open (FILE, "+>> $PrintcapPath"); 

#
# Write some comment in the $PrintcapPath file
#

print FILE "# FreEasy added network printer\n";

#
# Write the user choice in the file
#

if (length($LP) > 0) {

  print FILE "$Description|$LP:\\\n";
} else {
    print FILE "$Description:\\\n";
}

print FILE "  :lp=:\\\n";
print FILE "  :sh:sd=$SpoolPath:\\\n";
print FILE "  :rm=$RemoteName:\\\n";
print FILE "  :rp=$RemotePrinter:\\\n";

if ($Job eq "No") {
  print FILE "  :mx#0:\\\n";
} else {
    if ((length($JobSize) > 0) && ($JobSize !~ /\D/)) {
      print FILE "  :mx#$JobSize:\\\n";
    } else {
	print FILE "  :mx#1000:\\\n";
      }
  }

print FILE "  :sf:\n";

#
# Close the file
#

close(FILE);

}

# addnewprintertofile.pm
