package addnewprintertofile;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(add_new_printer_to_file);

sub add_new_printer_to_file {

#
# add new printer to printcap file
# (C) 1997 by Wouter de Boer
#
# Usage:
#    add_new_printer_to_file arg1, arg2, arg3, arg4, arg5, arg6,
#	arg7, arg8, arg9, arg10
#
#	arg1: Spool Directoru
#	arg2: Local printer (yes/no)
#	arg3: I/O port
#	arg4: Printer Name
#	arg5: PostScript (yes/no)
#	arg6: GhostScript Name
#	arg7: Log file Name (yes/no)
#	arg8: Limit Job Size (yes/no)
#	arg9: Otherprinter description
#	arg10: Limited Job size
#

#
# Get printer properties
#

my($SpoolPath, $LP, $IOPort, $Printer, $PS, $GSName, $Log, $Job, $Description, $JobSize) = @_;

#
# Location of printcap file
#

$PrintcapPath = "/etc/printcap";
$InputFilterPath = "/usr/local/libexec";

#
# Open the "/etc/printcap" file for writing, reading or
# create the file if not exists 
#

open (FILE, "+>> $PrintcapPath"); 

#
# Write some comment in the $PrintcapPath file
#

print FILE "# FreEasy added printer $Printer\n";

$Description =~ s/$SpoolName//g;
$Description =~ s/$Printer//g;
$Description =~ s/lp\|//g;
$Description =~ s/^\|//;
$Description =~ s/\|$//;
$Description =~ s/\|\|/\|/g;

#
# Write the user choice in the file
#

if (length($Description) > 0) {

  if (length($LP) > 0) {

    print FILE "$Description|$LP|$Printer:\\\n";
  } else {

      print FILE "$Description|$Printer:\\\n";
    }
} else {

    if (length($LP) > 0) {

      print FILE "$LP|$Printer:\\\n";
    } else {

      print FILE "$Printer:\\\n";
      }
}

print FILE "  :sh:sd=$SpoolPath:\\\n";
print FILE "  :lp=$IOPort:\\\n";

if ($PS eq "Yes") {

  print FILE "  :if=$InputFilterPath/$GSName:\\\n";
}

if ($Log eq "Yes") {
  print FILE "  :lf=$SpoolPath/$GSName.log:\\\n";
}

if ($Job eq "No") {
  print FILE "  :mx#0:\\\n";
} else {

    if ((length($JobSize) > 0) && ($JobSize !~ /\D/)) {

      print FILE "  :mx#$JobSize:\\\n";
    } else {

	print FILE "  :mx#1000:\\\n";
      }
}

print FILE "  :sf:\n";

#
# Close the file
#

close(FILE);

}

# addnewprintertofile.pm
