package changesysconfigfile;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(change_sysconfig_file add_ipaddress_and_netmask remove_network_card);

#
# change_sysconfig_file arg1
#
#     arg1: Associtive array
#
# add_ipaddress_and_netmask arg1, arg2, arg3
#
#     arg1: IP Address
#     arg2: Netmask number
#     arg3: Short card name (FreeBSD driver name)
#
# remove_network_card
#
#     arg1: Short card name (FreeBSD driver name)
#

use removeleadingspace;

#
# Location of sysconfig file
#

$SysConfigPath = "/etc/sysconfig";
$NewSysConfigPath = "/etc/newsysconfig";

sub change_sysconfig_file {

my (%AssocArray) = @_;

#
# open $SysConfigPath file for reading and
# open $NewSysConfigPath for writing
#

open (FILE, $SysConfigPath);
open (FILE1, "> $NewSysConfigPath");

while ($Line = <FILE>) {

  chop($Line);

  $Line = remove_leading_space $Line;

  @SubString = split(/=/, $Line);

  if (exists($AssocArray{$SubString[0]})) {

    print FILE1 "$SubString[0]=\"$AssocArray{$SubString[0]}\"\n";
  } else {

      print FILE1 "$Line\n";
    }
}

#
# Close the both files
# 

close (FILE);
close (FILE1);

#
# Copy the tempory one to the old one and remove the tempory one
#

system ("cp $NewSysConfigPath $SysConfigPath");

system ("rm $NewSysConfigPath");

}

sub add_ipaddress_and_netmask {

#
# Obtain the needed settings
#

my($IPAddress, $Netmask, $Card) = @_;

#
# open $SysConfigPath file for reading and
# open $NewSysConfigPath for writing
#

open (FILE, $SysConfigPath);
open (FILE1, "> $NewSysConfigPath");

while ($Line = <FILE>) {

  if ($Line =~ /^network_interfaces=/) {

    $Line =~ s/"$/ $Card"/;

    print FILE1 "$Line";
    print FILE1 "\nifconfig_$Card=\"inet $IPAddress  netmask $Netmask\"\n";
  } else {

      print FILE1 "$Line";
    }
}

#
# Close the both files
# 

close (FILE);
close (FILE1);

#
# Copy the tempory one to the old one and remove the tempory one
#

system ("cp $NewSysConfigPath $SysConfigPath");

system ("rm $NewSysConfigPath");

}

sub remove_network_card {

#
# Obtain the card
#

my($Card) = @_;

#
# open $SysConfigPath file for reading and
# open $NewSysConfigPath for writing
#

open (FILE, $SysConfigPath);
open (FILE1, "> $NewSysConfigPath");

while ($Line = <FILE>) {

  if ($Line =~ /^network_interfaces=/) {

    $Line =~ s/ $Card//;

    print FILE1 "$Line";
  } elsif ($Line =~ /ifconfig_$Card/) {

      $Line = <FILE>;

      print FILE1 "$Line";

    } else {

	print FILE1 "$Line";
      }
}

#
# Close the both files
# 

close (FILE);
close (FILE1);

#
# Copy the tempory one to the old one and remove the tempory one
#

system ("cp $NewSysConfigPath $SysConfigPath");

system ("rm $NewSysConfigPath");

}

# changesysconfigfile.pm
