package returnaudiocard;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_audio_card return_kernel_audio_cards);

use removeleadingspace;

sub return_audio_card {

my ($AudioCard) = $_[0];

#
# Decode the name of the $AudioCard. This is neccesary
# to know the fullname of the Audio card
#

SWITCH: {
  $Card = "SoundBlaster PCM", last SWITCH if ($AudioCard eq "sb0");
  $Card = "SoundBlaster 16", last SWITCH if ($AudioCard eq "sbxvi0");
  $Card = "SoundBlaster 16 MIDI", last SWITCH if ($AudioCard eq "sbmidi0");
  $Card = "ProAudioSpectrum PCM and Midi", last SWITCH if ($AudioCard eq "pas0");
  $Card = "Gravis Ultrasound", last SWITCH if ($AudioCard eq "gus0");
  $Card = "Gravis Ultrasound 16-bit PCM", last SWITCH if ($AudioCard eq "gusxvi0");
  $Card = "Microsoft Sound System", last SWITCH if ($AudioCard eq "mms0");
  $Card = "Yamaha OPL-2 and OPL-3 FM", last SWITCH if ($AudioCard eq "opl0");
  $Card = "stand-alone 6850 UART for MIDI", last SWITCH if ($AudioCard eq "uart0");
  $Card = "Roland MPU-401 stand-alone", last SWITCH if ($AudioCard eq "mpu0");
  $Card = "PCM audio through PC speaker", last SWITCH if ($AudioCard eq "pca0");
}

return $Card;

}

sub return_kernel_audio_cards {

#
# Return all supported audio cards by the kernel
# (c) 1997, by Wouter de Boer
#
# usage:
#     return_kernel_audio_cards arg1
#
#	arg1: Kernel Name
#

$KernelPath = "/usr/src/sys/i386/conf";

my($KernelName) = $_[0];

#
# All audio names in array
# 

my(@AudioArray) = ('sb0', 'sbxvi0', 'sbmidi0', 'pas0', 'gus0', 'gusxvi0', 'mss0', 'opl0', 'uart0', 'mpu0', 'pca0');

#
# Obtain size of audio names array
#

$Size = scalar @AudioArray;

#
# Variables used in this program
#

$EnabledCounter = 0;

#
# Open the file
#

open (FILE, "$KernelPath/$KernelName");

#
# Search for all above network card names
#

while ($Line = <FILE>) {

  $Line = remove_leading_space $Line;

  if (($Line =~ /snd0/) && ($Line !~/^#/)) {

    $SoundDeviceEnabled = "snd0";
  }

  for ($Counter = 0; $Counter < $Size; $Counter++) {

     @TempArray = split(/\s+/, $Line);

     if ($Line =~ /^device $AudioArray[$Counter]/) {

       $EnabledCardArray[$EnabledCounter] = $AudioArray[$Counter];

       if ($AudioArray[$Counter] eq "sbxvi0") {

         $EnabledPortArray[$EnabledCounter] = "";
         $EnabledIRQArray[$EnabledCounter] = "";
	 $EnabledDMAArray[$EnabledCounter++] = $TempArray[4];
       } elsif ($AudioArray[$Counter] eq "sbmidi0") {

	   $EnabledPortArray[$EnabledCounter] = $TempArray[5];
           $EnabledIRQArray[$EnabledCounter] = "";
	   $EnabledDMAArray[$EnabledCounter++] = "";
	 } elsif ($AudioArray[$Counter] eq "sb0") {

	     $EnabledPortArray[$EnabledCounter] = $TempArray[5];
             $EnabledIRQArray[$EnabledCounter] = $TempArray[7];
	     $EnabledDMAArray[$EnabledCounter++] = $TempArray[10];
	   } elsif ($AudioArray[$Counter] eq "opl0") {

	       $EnabledPortArray[$EnabledCounter] = $TempArray[5];
               $EnabledIRQArray[$EnabledCounter] = "";
	       $EnabledDMAArray[$EnabledCounter++] = "";
	     } elsif ($AudioArray[$Counter] eq "uart0") {

	         $EnabledPortArray[$EnabledCounter] = $TempArray[5];
                 $EnabledIRQArray[$EnabledCounter] = $TempArray[7];
	         $EnabledDMAArray[$EnabledCounter++] = "";
	       } elsif ($AudioArray[$Counter] eq "pca0") {

		   $EnabledPortArray[$EnabledCounter] = "";
                   $EnabledIRQArray[$EnabledCounter] = "";
	           $EnabledDMAArray[$EnabledCounter++] = "";
 	         } else {

	     	     $EnabledPortArray[$EnabledCounter] = $TempArray[5];
	     	     $EnabledIRQArray[$EnabledCounter] = $TempArray[7];
		     $EnabledDMAArray[$EnabledCounter++] = $TempArray[9];
		   }
     } 
  }
}

#
# Close the file
#

close (FILE);

return ($SoundDeviceEnabled, $Size, \@EnabledCardArray, \@EnabledPortArray, \@EnabledIRQArray, \@EnabledDMAArray, \@AudioArray);

}

# returnnetworkcard.pm