package returnnetworkcard;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_network_card return_kernel_network_cards);

use removeleadingspace;

sub return_network_card {

my ($NetworkCard) = $_[0];

#
# Decode the name of the $NetworkCard. This is neccesary
# to know the fullname of the Network card
#

SWITCH: {
  $Card = "Arnet SYNC/570i", last SWITCH if ($NetworkCard eq "ar0");
  $Card = "Cronyx/Sigma", last SWITCH if ($NetworkCard eq "cx0");
  $Card = "DE DC21040", last SWITCH if ($NetworkCard eq "de0");
  $Card = "NE2000 compatible", last SWITCH if ($NetworkCard eq "ed0");
  $Card = "NE2000 compatible", last SWITCH if ($NetworkCard eq "ed1");
  $Card = "3Com 3C505", last SWITCH if ($NetworkCard eq "eg0");
  $Card = "3Com 3C501", last SWITCH if ($NetworkCard eq "el0");
  $Card = "3Com 3C509", last SWITCH if ($NetworkCard eq "ep0");
  $Card = "Intel EthetExpress Pro/10", last SWITCH if ($NetworkCard eq "ex0");
  $Card = "Fujitsu Ethernet", last SWITCH if ($NetworkCard eq "fe0");
  $Card = "DEC EISA", last SWITCH if ($NetworkCard eq "fea0");
  $Card = "DEFPA PCI FDDI", last SWITCH if ($NetworkCard eq "fpa0");
  $Card = "Intel EtherExpress Pro/100B PCI", last SWITCH if ($NetworkCard eq "fxp0");
  $Card = "3Com 3C507 compatible", last SWITCH if ($NetworkCard eq "ie0");
  $Card = "Intel EtherExpress 16", last SWITCH if ($NetworkCard eq "ix0");
  $Card = "DEPCA compatible", last SWITCH if ($NetworkCard eq "le0");
  $Card = "NE2100 compatible", last SWITCH if ($NetworkCard eq "lnc0");
  $Card = "RISCom/N2", last SWITCH if ($NetworkCard eq "sr0");
  $Card = "3Com 3C590/3C595", last SWITCH if ($NetworkCard eq "vx0");
  $Card = "PCMCIA compatible", last SWITCH if ($NetworkCard eq "ze0");
  $Card = "3Com PCMCIA", last SWITCH if ($NetworkCard eq "zp0");
}

return $Card;

}

sub return_kernel_network_cards {

#
# Return all supported network cards by the kernel
# (c) 1997, by Wouter de Boer
#
# usage:
#     return_kernel_network_cards arg1
#
#	arg1: Kernel Name
#

$KernelPath = "/usr/src/sys/i386/conf";

my($KernelName) = $_[0];

#
# All network names in array
# 

my(@NetworkArray) = ('ar0', 'cx0', 'de0', 'ed0', 'ed1', 'eg0', 'el0', 'ep0', 'ex0', 'fe0', 'fea0', 'fpa0', 'fxp0', 'ie0', 'ix0', 'le0', 'lnc0', 'sr0', 'vx0', 'ze0', 'zp0');

#
# Obtain size of network names array
#

$Size = scalar @NetworkArray;

#
# Variables used in this program
#

$DisabledCounter = $EnabledCounter = 0;

#
# Open the file
#

open (FILE, "$KernelPath/$KernelName");

#
# Search for all above network card names
#

while ($Line = <FILE>) {

  $Line = remove_leading_space $Line;

  for ($Counter = 0; $Counter < $Size; $Counter++) {

     @TempArray = split(/\s+/, $Line);

     if ($Line =~ /^device $NetworkArray[$Counter]/) {

       $EnabledCardArray[$EnabledCounter] = $NetworkArray[$Counter];
       $EnabledPortArray[$EnabledCounter] = $TempArray[5];
       $EnabledIRQArray[$EnabledCounter++] = $TempArray[8];
     } elsif ($Line =~ /^\#device $NetworkArray[$Counter]/) {

         $DisabledCardArray[$DisabledCounter] = $NetworkArray[$Counter];
         $DisabledPortArray[$DisabledCounter] = $TempArray[5];
         $DisabledIRQArray[$DisabledCounter++] = $TempArray[8];
       }
  }
}

#
# Close the file
#

close (FILE);

return ($Size, \@EnabledCardArray, \@EnabledPortArray, \@EnabledIRQArray, \@DisabledCardArray, \@DisabledPortArray, \@DisabledIRQArray, \@NetworkArray);

}

# returnnetworkcard.pm
