package returnport;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_iopath return_ioname return_freebsd_ioname);

sub return_iopath {

#
# Return the I/O port path for FreeBSD
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_iopath arg1
#
#	arg1: I/O port path
#

#
# Get I/O Port
#

my($Port) = $_[0];

#
# Select the right I/O port 
#

SWITCH: {
  $Port = "/dev/lpt0", last SWITCH if ($Port eq "lpt0");
  $Port = "/dev/lpt1", last SWITCH if ($Port eq "lpt1");
  $Port = "/dev/cuaa0", last SWITCH if ($Port eq "cuaa0");
  $Port = "/dev/cuaa1", last SWITCH if ($Port eq "cuaa1");
  $Port = "/dev/cuaa2", last SWITCH if ($Port eq "cuaa2");
  $Port = "/dev/cuaa3", last SWITCH if ($Port eq "cuaa3");
}

return $Port;

}

sub return_ioname {

#
# Return the I/O port name for FreeBSD
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_ioname arg1
#
#	arg1: I/O port path
#

#
# Get I/O Port
#

my($Port) = $_[0];

#
# Select the right I/O port 
#

SWITCH: {
  $Port = "LPT1", last SWITCH if ($Port eq "/dev/lpt0");
  $Port = "LPT2", last SWITCH if ($Port eq "/dev/lpt1");
  $Port = "COM1", last SWITCH if ($Port eq "/dev/cuaa0");
  $Port = "COM2", last SWITCH if ($Port eq "/dev/cuaa1");
  $Port = "COM3", last SWITCH if ($Port eq "/dev/cuaa2");
  $Port = "COM4", last SWITCH if ($Port eq "/dev/cuaa3");
}

return $Port;

}

sub return_freebsd_ioname {

#
# Return the I/O port name in FreeBSD
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_freebsd_ioname arg1
#
#	arg1: I/O port path
#

#
# Get I/O Port
#

my($Port) = $_[0];

#
# Select the right I/O port 
#

SWITCH: {
  $Port = "lpt0", last SWITCH if ($Port eq "/dev/lpt0");
  $Port = "lpt1", last SWITCH if ($Port eq "/dev/lpt1");
  $Port = "cuaa0", last SWITCH if ($Port eq "/dev/cuaa0");
  $Port = "cuaa1", last SWITCH if ($Port eq "/dev/cuaa1");
  $Port = "cuaa2", last SWITCH if ($Port eq "/dev/cuaa2");
  $Port = "cuaa3", last SWITCH if ($Port eq "/dev/cuaa3");
}

return $Port;

}

# returnport.pm