package returnprintcapsettings;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_printcap_settings);

#
# return all the printcap settings file for FreeBSD
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_printcap_settings
#

sub return_printcap_settings {

use removeleadingspace;

#
# Location of file
#

$PrintcapPath = "/etc/printcap";

#
# Variables used in this program
#

$ArrayCounter = 0;

#
# Open the file
#

open (FILE, $PrintcapPath);

#
# Read file line by line
#

while ($Line = <FILE>) {

   $Line = remove_leading_space $Line;

   if (($Line !~ /^\#/) && (&NotEmptyLine($Line))) {

     while ($Line =~ /\\$/) {

       chop($Line);
       $Line =~ s/:\\$//;
       @PrinterSettings[$ArrayCounter] .= $Line;
       $Line = <FILE>;
       $Line = remove_leading_space $Line;
     }

     chop($Line);
     @PrinterSettings[$ArrayCounter] .= $Line;
     $ArrayCounter++;

   }
}

#
# Close the file
#

close (FILE);

#
# Return the printer settings
#

return @PrinterSettings;

}

# returnprintcapsettings.pm

sub NotEmptyLine {

my ($Line) = $_[0];

if (length($Line) > 0) {

  return 1;

} else {

  return 0;
}

}
