package returnprintername;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_printer_definition return_short_printer_name);

sub return_printer_definition {

    #
    # Return printer definition for FreeBSB
    # (C) 1997 by Wouter de Boer
    #
    # Usage:
    #    return_printer_definition arg1
    #
    #	arg1: PrintcapArray
    #

    #
    # Obtain all the printcap settings
    #

    my(@PrintcapArray) = @_;

    #
    # Initialize variable;
    #

    $ArrayCounter = 0;

    #
    # Obtain all last part of the string
    #

    $Size = scalar @PrintcapArray;

    for ($ArrayCounter = $TempCounter = 0; $ArrayCounter < $Size; $ArrayCounter++) {

	@TempArray = split (/:/, @PrintcapArray[$ArrayCounter]);
	$PrinterName = @TempArray[0];
	@TempArray = split (/\|/, $PrinterName);
	$TempSize = (scalar @TempArray) - 1;
	@AllPrinterDefinition[$TempCounter++] = @TempArray[$TempSize];
	@AllPrinterDefinition[$TempCounter++] = " (@TempArray[0])";
    }

    #
    # Return with all printer definitions. That means all last name of the
    # line in the printcap file
    #

    return @AllPrinterDefinition;
}

sub return_short_printer_name {

# 
# Return short printer definition for FreeBSB
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_short_printer_name arg1
#
#		arg1: PrinterName
#

#
# Get the Printer name
#

my($Printer) = $_[0];

#
# Decode the name of the $Printer. This is neccesary
# to know the name for the GhostScript program and log file
#

SWITCH: {
  $GSName = "bj10e", last SWITCH if ($Printer eq "Canon BubbleJet BJ10e"); 
  $GSName = "bj200", last SWITCH if ($Printer eq "Canon BubbleJet BJ200");
  $GSName = "lbp8", last SWITCH if ($Printer eq "Canon LBP-8II");
  $GSName = "la50", last SWITCH if ($Printer eq "Dec LA50");
  $GSName = "la75", last SWITCH if ($Printer eq "Dec LA75");
  $GSName = "declj250", last SWITCH if ($Printer eq "Dec LJ250");
  $GSName = "lj250", last SWITCH if ($Printer eq "Dec LJ250 Companion Color");
  $GSName = "ln03", last SWITCH if ($Printer eq "Dec LN03");
  $GSName = "epson", last SWITCH if ($Printer eq "Epson compatible dot-matrix (9- or 24 pin)");
  $GSName = "epshigh", last SWITCH if ($Printer eq "Epson compatible 9-pin in triple resolution");
  $GSName = "epsonc", last SWITCH if ($Printer eq "Epson LQ-2550 color");
  $GSName = "escp2", last SWITCH if ($Printer eq "Epson, such as Stylus 800, that use ESC/P 2");
  $GSName = "epsonc", last SWITCH if ($Printer eq "Fujitsu 1200/2400/3400 color");
  $GSName = "deskjet", last SWITCH if ($Printer eq "HP DeskJet");
  $GSName = "deskjet", last SWITCH if ($Printer eq "HP DeskJet Plus");
  $GSName = "djet500", last SWITCH if ($Printer eq "HP DeskJet 500");
  $GSName = "djet500c", last SWITCH if ($Printer eq "HP DeskJet 500C");
  $GSName = "cdjmono", last SWITCH if ($Printer eq "HP DeskJet 500C in black-and-white mode");
  $GSName = "cdeskjet", last SWITCH if ($Printer eq "HP DeskJet 500C with 1-bit-per-pixel mode");
  $GSName = "cdjcolor", last SWITCH if ($Printer eq "HP DeskJet 500C with 24-bits-per-pixel mode");
  $GSName = "cdj550", last SWITCH if ($Printer eq "HP DeskJet 550C");
  $GSName = "laserjet", last SWITCH if ($Printer eq "HP LaserJet");
  $GSName = "ljetplus", last SWITCH if ($Printer eq "HP LaserJet Plus");
  $GSName = "ljet2p", last SWITCH if ($Printer eq "HP LaserJet IID");
  $GSName = "ljet2p", last SWITCH if ($Printer eq "HP LaserJet IIP");
  $GSName = "ljet2p", last SWITCH if ($Printer eq "HP LaserJet III with TIFF compression");
  $GSName = "ljet3", last SWITCH if ($Printer eq "HP LaserJet III with Delta Row compression");
  $GSName = "ljet4", last SWITCH if ($Printer eq "HP LaserJet 4");
  $GSName = "paintjet", last SWITCH if ($Printer eq "HP PaintJet color");
  $GSName = "pj", last SWITCH if ($Printer eq "HP PaintJet XL");
  $GSName = "pjxl", last SWITCH if ($Printer eq "HP PaintJet XL color");
  $GSName = "pjxl300", last SWITCH if ($Printer eq "HP PaintJet XL300 color");
  $GSName = "ibmpro", last SWITCH if ($Printer eq "IBM 9-pin Proprinter");
  $GSName = "jetp3852", last SWITCH if ($Printer eq "IBM Jetprinter (Model #3852) inkjet color");
  $GSName = "necp6", last SWITCH if ($Printer eq "NEC P6");
  $GSName = "necp6", last SWITCH if ($Printer eq "NEC P6+");
  $GSName = "necp6", last SWITCH if ($Printer eq "NEC P60");
  $GSName = "r4081", last SWITCH if ($Printer eq "Ricoh 4081");
  $GSName = "t4693d2", last SWITCH if ($Printer eq "Tektronix 4693d, 2 bits per RGB component");
  $GSName = "t4693d4", last SWITCH if ($Printer eq "Tektronix 4693d, 4 bits per RGB component");
  $GSName = "t4693d8", last SWITCH if ($Printer eq "Tektronix 4693d, 8 bits per RGB component");
  $GSName = "tek4696", last SWITCH if ($Printer eq "Tektronix 4695 inkjet plotter");
  $GSName = "tek4696", last SWITCH if ($Printer eq "Tektronix 4696 inktjet plotter");
}

return $GSName;

}

# returnprintername.pm
