package returnprintersettings;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_printer_settings);

sub return_printer_settings {

#
# Return printer settings file for FreeBSD
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_printer_settings arg1
#
#	arg1: Printer Name
#

use returnprintcapsettings;
use returnsettings;

#
# Get Printer Name
#

my($PrinterName) = $_[0];

#
# Return with all lines of printecap file
#

@AllPrintcapSettings = return_printcap_settings;

#
# Obtian the size of array
# 

$Size = scalar @AllPrintcapSettings;

#
# Search for the printer name
#

for ($ArrayCounter = 0; $ArrayCounter < $Size; $ArrayCounter++) {

   @TempArray = split(/:/, $AllPrintcapSettings[$ArrayCounter]);

   @Temp_Array = split(/\|/, $TempArray[0]);

   $TempSize = scalar @Temp_Array;

   for ($Counter = 0; $Counter < $TempSize; $Counter++) {

      if ($Temp_Array[$Counter] eq $PrinterName) {

        %SettingsArray = return_settings $AllPrintcapSettings[$ArrayCounter], $PrinterName;
      }
   }
}

#
# Divide all settings about variables
#

$Description = $SettingsArray{"desc"};

$LP = "No";

if ($Description eq "lp") {
  
  $LP = "Yes";
} else {

    @TempArray = split (/\|/, $Description);

    $TempSize = scalar @TempArray;

    for ($TempCounter = 0; $TempCounter < $TempSize; $TempCounter++) {

       if ($TempArray[$TempCounter] eq "lp") {

	 $LP = "Yes";

       }
    }
  }

$GS = $SettingsArray{"gs"};

if (!($GS eq "No")) {

  if (length($GS) > 0) {
  
    $InputFilterPath = $GS;
    $GS = "Yes";
  } else {

      $GS = "No";
    }
}

$Log = $SettingsArray{"lg"};

if (!($Log eq "No")) {

  if (length($Log) > 0) {
    $LogFilePath = $Log;
    $Log = "Yes";
  } else {

      $Log = "No";
    }
}

$IOPort = $SettingsArray{"lp"};
$SpoolPath = $SettingsArray{"sd"};
$Job = $SettingsArray{"mx"};
$RemoteName = $SettingsArray{"rm"};
$RemotePrinter = $SettingsArray{"rp"};

#
# Return with printer settings
#

return ($Description, $LP, $IOPort, $SpoolPath, $GS, $Log, $Job, $RemoteName, $RemotePrinter, $InputFilterPath, $LogFilePath);

}

# returnprintersettings.pm
