package returnscsiadapter;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_scsi_adapter_name return_kernel_scsi_adapter);

use removeleadingspace;

sub return_scsi_adapter_name {

my ($SCSICard) = $_[0];

#
# Decode the name of the $SCSICard. This is neccesary
# to know the fullname of the SCSI adapter card
#

SWITCH: {
  $Card = "Adaptec 154x", last SWITCH if ($SCSICard eq "aha0");
  $Card = "Adaptec 274x/284x/294x", last SWITCH if ($SCSICard eq "ahc0");
  $Card = "Adaptec 152x/AIC-6360", last SWITCH if ($SCSICard eq "aic0");
  $Card = "Buslogic controller", last SWITCH if ($SCSICard eq "bt0");
  $Card = "ProAudioSpectrum using NCR 5380/Trantor TI30", last SWITCH if ($SCSICard eq "nca0");
  $Card = "", last SWITCH if ($SCSICard eq "nca1");
  $Card = "", last SWITCH if ($SCSICard eq "nca2");
  $Card = "", last SWITCH if ($SCSICard eq "nca3");
  $Card = "", last SWITCH if ($SCSICard eq "nca4");
  $Card = "Seagate ST01/02", last SWITCH if ($SCSICard eq "sea0");
  $Card = "UltraStore 14F/34F", last SWITCH if ($SCSICard eq "uha0");
  $Card = "Western Digital WD7000", last SWITCH if ($SCSICard eq "wds0");
  $Card = "Adaptec 174x EISA", last SWITCH if ($SCSICard eq "ahb0");
  $Card = "Adaptec 274x/284x EISA", last SWITCH if ($SCSICard eq "ahc0");
  $Card = "Adaptec 29/3940, AIC7870/7880 PCI", last SWITCH if ($SCSICard eq "ahc1");
  $Card = "NCR 53C810/53C825 PCI", last SWITCH if ($SCSICard eq "ncr0");
  $Card = "Tekram DC-390/390T (AMD 53c974) PCI", last SWITCH if ($SCSICard eq "amd0");
}

return $Card;

}

sub return_kernel_scsi_adapter {

#
# Return all supported SCSI adapter cards by the kernel
# (c) 1997, by Wouter de Boer
#
# usage:
#     return_kernel_scsi_adapter arg1
#
#	arg1: Kernel Name
#

$KernelPath = "/usr/src/sys/i386/conf";

my($KernelName) = $_[0];

#
# All network names in array
# 

my(@SCSIArray) = ('bt0', 'aha0', 'uha0', 'aic0', 'nca0', 'nca1', 'nca2', 'nca3', 'nca4', 'sea0', 'wds0', 'ahb0', 'ahc0', 'ahc1', 'ncr0', 'amd0');

#
# Obtain size of SCSI names array
#

$Size = scalar @SCSIArray;

#
# Variables used in this program
#

$DisabledCounter = $EnabledCounter = 0;

#
# Open the file
#

open (FILE, "$KernelPath/$KernelName");

#
# Search for all above SCSI adapter card names
#

while ($Line = <FILE>) {

  $Line = remove_leading_space $Line;

  for ($Counter = 0; $Counter < $Size; $Counter++) {

     @TempArray = split(/\s+/, $Line);

     if (($Line =~ /^controller/) && ($Line =~ /$SCSIArray[$Counter]/)) {

       if ($SCSIArray[$Counter] eq "bt0") {

	 $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
         $EnabledPortArray[$EnabledCounter] = "";
         $EnabledIRQArray[$EnabledCounter] = $TempArray[8];
	 $EnabledDMAArray[$EnabledCounter++] = "";
       } elsif (($SCSIArray[$Counter] eq "aha0") || ($SCSIArray[$Counter] eq "uha0")) {

	   $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
	   $EnabledPortArray[$EnabledCounter] = "";
	   $EnabledIRQArray[$EnabledCounter] = $TempArray[8];
	   $EnabledDMAArray[$EnabledCounter++] = $TempArray[10];
         } elsif (($SCSIArray[$Counter] eq "aic0") || ($SCSIArray[$Counter] eq "nca0") || ($SCSIArray[$Counter] eq "nca4")) {

	     $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
	     $EnabledPortArray[$EnabledCounter] = $TempArray[5];
	     $EnabledIRQArray[$EnabledCounter] = $TempArray[8];
	     $EnabledDMAArray[$EnabledCounter++] = "";
	   } elsif (($SCSIArray[$Counter] eq "nca1") || ($SCSIArray[$Counter] eq "nca2") || ($SCSIArray[$Counter] eq "nca3")) {


	       $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
	       $EnabledPortArray[$EnabledCounter] = $TempArray[5];
	       $EnabledIRQArray[$EnabledCounter] = "";
	       $EnabledDMAArray[$EnabledCounter++] = "";
	     } elsif ($SCSIArray[$Counter] eq "sea0") {

		 $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
		 $EnabledPortArray[$EnabledCounter] = "";
		 $EnabledIRQArray[$EnabledCounter] = $TempArray[6];
		 $EnabledDMAArray[$EnabledCounter++] = "";
	       } elsif ($SCSIArray[$Counter] eq "wds0") {

		   $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
		   $EnabledPortArray[$EnabledCounter] = $TempArray[5];
		   $EnabledIRQArray[$EnabledCounter] = $TempArray[8];
		   $EnabledDMAArray[$EnabledCounter++] = $TempArray[10];
	         } elsif (($SCSIArray[$Counter] eq "ahb0") || ($SCSIArray[$Counter] eq "ahc0") || ($SCSIArray[$Counter] eq "ahc1") || ($SCSIArray[$Counter] eq "ncr0") || ($SCSIArray[$Counter] eq "amd0")) {


		     $EnabledCardArray[$EnabledCounter] = $SCSIArray[$Counter];
		     $EnabledPortArray[$EnabledCounter] = "";
		     $EnabledIRQArray[$EnabledCounter] = "";
		     $EnabledDMAArray[$EnabledCounter++] = "";
		   }

     } elsif (($Line =~ /^\#controller/) && ($Line =~ /$SCSIArray[$Counter]/)) {

	 if ($SCSIArray[$Counter] eq "bt0") {

	   $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
           $DisabledPortArray[$DisabledCounter] = "";
           $DisabledIRQArray[$DisabledCounter] = $TempArray[8];
	   $DisabledDMAArray[$DisabledCounter++] = "";
         } elsif (($SCSIArray[$Counter] eq "aha0") || ($SCSIArray[$Counter] eq "uha0")) {

	     $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
	     $DisabledPortArray[$DisabledCounter] = "";
	     $DisabledIRQArray[$DisabledCounter] = $TempArray[8];
	     $DisabledDMAArray[$DisabledCounter++] = $TempArray[10];
           } elsif (($SCSIArray[$Counter] eq "aic0") || ($SCSIArray[$Counter] eq "nca0") || ($SCSIArray[$Counter] eq "nca4")) {

	       $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
	       $DisabledPortArray[$DisabledCounter] = $TempArray[5];
	       $DisabledIRQArray[$DisabledCounter] = $TempArray[8];
	       $DisabledDMAArray[$DisabledCounter++] = "";
	     } elsif (($SCSIArray[$Counter] eq "nca1") || ($SCSIArray[$Counter] eq "nca2") || ($SCSIArray[$Counter] eq "nca3")) {


		 $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
		 $DisabledPortArray[$DisabledCounter] = $TempArray[5];
		 $DisabledIRQArray[$DisabledCounter] = "";
		 $DisabledDMAArray[$DisabledCounter++] = "";
	       } elsif ($SCSIArray[$Counter] eq "sea0") {

		   $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
		   $DisabledPortArray[$DisabledCounter] = "";
		   $DisabledIRQArray[$DisabledCounter] = $TempArray[6];
		   $DisabledDMAArray[$DisabledCounter++] = "";
	         } elsif ($SCSIArray[$Counter] eq "wds0") {

		     $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
		     $DisabledPortArray[$DisabledCounter] = $TempArray[5];
		     $DisabledIRQArray[$DisabledCounter] = $TempArray[8];
		     $DisabledDMAArray[$DisabledCounter++] = $TempArray[10];
	           } elsif (($SCSIArray[$Counter] eq "ahb0") || ($SCSIArray[$Counter] eq "ahc0") || ($SCSIArray[$Counter] eq "ahc1") || ($SCSIArray[$Counter] eq "ncr0") || ($SCSIArray[$Counter] eq "amd0")) {


		       $DisabledCardArray[$DisabledCounter] = $SCSIArray[$Counter];
		       $DisabledPortArray[$DisabledCounter] = "";
		       $DisabledIRQArray[$DisabledCounter] = "";
		       $DisabledDMAArray[$DisabledCounter++] = "";
		     }

       }
  }
}

#
# Close the file
#

close (FILE);

return ($Size, $EnabledCounter, $DisabledCounter, \@EnabledCardArray, \@EnabledPortArray, \@EnabledIRQArray, \@EnabledDMAArray, \@DisabledCardArray, \@DisabledPortArray, \@DisabledIRQArray, \@DisabledDMAArray, \@SCSIArray);

}

# returnnetworkcard.pm
