package returntimezonename;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(return_timezone_names return_current_timezone);

sub return_timezone_names {

#
# return all names from a specified directory in /usr/share/timezone/??
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_timezone_names arg1
#
#	arg1: TimeZone Directory
#

#
# Get TimeZone Directory
#

my($TimeZoneDir) = $_[0];

#
# Variable used in this program
#

my($ArrayCounter) = 0;

#
# Location of files
#

$TimeZonePath = "/usr/share/zoneinfo";

#
# Open the $TimeZonePath/$TimeZoneDir for reading
#

opendir (DIR, "$TimeZonePath/$TimeZoneDir"); 

$Entry = readdir (DIR);

while (length($Entry) > 0) {

  if ((!($Entry eq ".")) && (!($Entry eq ".."))) {

    $AllNames[$ArrayCounter++] = $Entry;
  }

  $Entry = readdir (DIR);
}

#
# Close the directory
#

closedir (DIR);

#
# Sort the content of the array and return it

@AllNames = sort @AllNames;

return @AllNames;

}

sub return_current_timezone {

#
# return current timezone 
# (C) 1997 by Wouter de Boer
#
# Usage:
#    return_current_timezone
#

$Date = `date`;

SWITCH: {

$TimeZone = "Newfoundland Daylight", last SWITCH if ($Date =~ /NDT/);
$TimeZone = "Atlantic Daylight", last SWITCH if ($Date =~ /ADT/);
$TimeZone = "Eastern Daylight", last SWITCH if ($Date =~ /EDT/);
$TimeZone = "Central Daylight", last SWITCH if ($Date =~ /CDT/);
$TimeZone = "Mountain Daylight", last SWITCH if ($Date =~ /MDT/);
$TimeZone = "Yukon Daylight", last SWITCH if ($Date =~ /YDT/);
$TimeZone = "Hawaii Daylight", last SWITCH if ($Date =~ /HDT/);
$TimeZone = "British Summer/Brazil Standard", last SWITCH if ($Date =~ /BST/);
$TimeZone = "Middle European Summer", last SWITCH if ($Date =~ /MEST/);
$TimeZone = "Swedish Summer/South Sumatra, USSR Zone 6", last SWITCH if ($Date =~ /SST/);
$TimeZone = "French Summer", last SWITCH if ($Date =~ /FST/);
$TimeZone = "West Australian Daylight", last SWITCH if ($Date =~ /WADT/);
$TimeZone = "Central Australian Daylight", last SWITCH if ($Date =~ /CADT/);
$TimeZone = "Eastern Australian Daylight", last SWITCH if ($Date =~ /EADT/);
$TimeZone = "New Zealand Daylight", last SWITCH if ($Date =~ /NZDT/);
$TimeZone = "Greenwich Mean", last SWITCH if ($Date =~ /GMT/);
$TimeZone = "Universal", last SWITCH if ($Date =~ /UT/);
$TimeZone = "Universal Coordinated", last SWITCH if ($Date =~ /UCT/);
$TimeZone = "Western European", last SWITCH if ($Date =~ /WET/);
$TimeZone = "West Africa", last SWITCH if ($Date =~ /WAT/);
$TimeZone = "Azores", last SWITCH if ($Date =~ /AT/);
$TimeZone = "Greenland/Guam, USSR Zone 9 Standard", last SWITCH if ($Date =~ /GST/);
$TimeZone = "Newfoundland", last SWITCH if ($Date =~ /NFT/);
$TimeZone = "Newfoundland Standard/North Sumatra", last SWITCH if ($Date =~ /NST/);
$TimeZone = "Atlantic Standard", last SWITCH if ($Date =~ /AST/);
$TimeZone = "Eastern Standard", last SWITCH if ($Date =~ /EST/);
$TimeZone = "Central Standard", last SWITCH if ($Date =~ /CST/);
$TimeZone = "Mountain Standard", last SWITCH if ($Date =~ /MST/);
$TimeZone = "Pacific Standard", last SWITCH if ($Date =~ /PST/);
$TimeZone = "Yokun Standard", last SWITCH if ($Date =~ /YST/);
$TimeZone = "Hawaii Standard", last SWITCH if ($Date =~ /HST/);
$TimeZone = "Alaska-Hawaii Standard", last SWITCH if ($Date =~ /AHST/);
$TimeZone = "Central Alaska", last SWITCH if ($Date =~ /CAT/);
$TimeZone = "Nome", last SWITCH if ($Date =~ /NT/);
$TimeZone = "International Date Line West", last SWITCH if ($Date =~ /IDLW/);
$TimeZone = "Central European", last SWITCH if ($Date =~ /CET/);
$TimeZone = "Middle European", last SWITCH if ($Date =~ /MET/);
$TimeZone = "Middle European Winter", last SWITCH if ($Date =~ /MEWT/);
$TimeZone = "Swedish Winter", last SWITCH if ($Date =~ /SWT/);
$TimeZone = "French Winter", last SWITCH if ($Date =~ /FWT/);
$TimeZone = "Eastern Europe, USSR Zone 1", last SWITCH if ($Date =~ /EET/);
$TimeZone = "Baghdad, USSR Zone 2", last SWITCH if ($Date =~ /BT/);
$TimeZone = "Iran", last SWITCH if ($Date =~ /IT/);
$TimeZone = "USSR Zone 3", last SWITCH if ($Date =~ /ZP4/);
$TimeZone = "USSR Zone 4", last SWITCH if ($Date =~ /ZP5/);
$TimeZone = "Indian Standard", last SWITCH if ($Date =~ /IST/);
$TimeZone = "USSR Zone 5", last SWITCH if ($Date =~ /ZP6/);
$TimeZone = "USSR Zone 3", last SWITCH if ($Date =~ /ZP4/);
$TimeZone = "West Australian Standard", last SWITCH if ($Date =~ /WAST/);
$TimeZone = "Java (3pm in Cronusland!)", last SWITCH if ($Date =~ /JT/);
$TimeZone = "China Coast, USSR Zone 7", last SWITCH if ($Date =~ /CCT/);
$TimeZone = "Japan Standard, USSR Zone 8", last SWITCH if ($Date =~ /JST/);
$TimeZone = "Central Australian Standard", last SWITCH if ($Date =~ /CAST/);
$TimeZone = "East Australian Standard", last SWITCH if ($Date =~ /EAST/);
$TimeZone = "West Australian Standard", last SWITCH if ($Date =~ /WAST/);
$TimeZone = "New Zealand", last SWITCH if ($Date =~ /NZT/);
$TimeZone = "New Zealand Standard", last SWITCH if ($Date =~ /NZST/);
$TimeZone = "International Date Line East", last SWITCH if ($Date =~ /IDLE/);
}

return $TimeZone;

}

# returntimezonename.pm


