package verify;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(verifyID verify_name verify_passwd verify_xdm_terminal verify_lp);

#use nummeric;

#
# verify ID or username file for FreeBSB
# (C) 1997 by Wouter de Boer
#
# Usage:
#    verifyID arg1, arg2
#
#	arg1: ID number
#       arg2: Path
#
#    verify_name arg1, arg2
#	
#	arg1: Name
#	arg2: Path 
#
#    verify_passwd arg1, arg2
#
#       arg1: User name
#       arg2: Password
#
#    verify_xdm_terminal arg1, arg2, arg3
#
#	arg1: Size of virtual terminal array
#	arg2: xdm virtual terminal name
#	arg3: Changed virtual terminal array
#
#    verify_lp arg1
#
#       arg1: Printer description
#

sub verifyID {

#
# Obtain ID and Path
#

local($ID) = $_[0];
local($Path) = $_[1];

#
# open the file
#

open (FILE, $Path);

#
# Store all group ID's into an array 
# 

local($Counter) = 0;

while ($Line = <FILE>) {

  $FileID = (split (/:/, $Line))[2];
  @IDArray[$Counter] = $FileID;
  $Counter++;
}

#
# Close the file
#

close(FILE);

#
# Obtain Size of array
#

local($Size) = scalar @IDArray;

#
# Look if ID is used. Yes, increment ID and look again.
#

for ($Counter = 0; $Counter < $Size; $Counter++) {

   if (@IDArray[$Counter] == $ID) {
     $ID++;
     $Counter = 0;
   }
}

#
# Return with the valid ID
#

return $ID;

}

sub verify_name {

#
# Obtain ID and Path
#

local($Name) = $_[0];
local($Path) = $_[1];

#
# open the file
#

#
# If Name not found return with "1" else with "0"
#

$ReturnValue = 1;

open (FILE, $Path);

while ($Line = <FILE>) {

  $FileName = (split (/:/, $Line))[0];
  if ($FileName eq $Name) {
    $ReturnValue = 0;
  }
}

return $ReturnValue;

}

sub verify_passwd {

#
# Obtain UserName and Passwd
#

local($UserName) = $_[0];
local($Passwd) = $_[1];

#
# Location od master.passwd file
#

my($MasterPath) = "/etc/master.passwd";

#
# open the file
#

#
# If Name not found return with "1" else with "0"
#

open (FILE, $MasterPath);

while ($Line = <FILE>) {

  $FileName = (split (/:/, $Line))[0];
  if ($FileName eq $UserName) {

    $FilePasswd = (split (/:/, $Line))[1];
    if (crypt($Passwd, $FilePasswd) eq $FilePasswd) {
 
      $ReturnValue = 0;
    } else {
        
        $ReturnValue = 1;
      }
  }
}

return $ReturnValue;

}

sub verify_xdm_terminal {

#
# Obtain the xdm virtual terminal name and the virtual terminal array
#

my($Size, $XDM, @VirtualTerminalArray) = @_;

my($Valid_Value) = 0;

for ($ArrayCounter = 0; $ArrayCounter < $Size; $ArrayCounter++) {

   if ($XDM eq $VirtualTerminalArray[$ArrayCounter]) {

     $Valid_Value = 1;
   }
}

return $Valid_Value;

}

sub verify_lp {

#
# Obtain the printer description
#

my($Description) = @_;

my($VerifyLP) = 0;

#
# Search if user has typed "lp" in description
#

@TempArray = split(/\|/, $Description);

$TempSize = scalar @TempArray;



for ($ArrayCounter = 0; $ArrayCounter < $TempSize; $ArrayCounter++) {

   if ($TempArray[$ArrayCounter] eq "lp") {

     $VerifyLP = 1;
   }
}

return $VerifyLP;

}

# verify.pm


