package writechangedprinter;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(write_changed_printer_settings);

sub write_changed_printer_settings {

#
# add network printer to printcap file
# (C) 1997 by Wouter de Boer
#
# Usage:
#    write_changed_printer_settings arg1, arg2, arg3, arg4, arg5, arg6
#	arg7, arg8, arg9, arg10, arg11, arg12
#
#	arg1: Spool Directory
#	arg2: Local printer (yes/no)
#	arg3: Limit Job Size (yes/no)
#	arg4: Otherprinter description
#	arg5: PostScript (yes/no)
#	arg6: Log file (yes/no)
#	arg7: Printer Name
#	arg8: I/O Port
#	arg9: GhostScrip Name
#	arg10: Limited Job Size
#	arg11: Remote Name
#	arg12: Remote Printer
#

use removeleadingspace;

#
# Get printer properties
#

my($SpoolPath, $LP, $Job, $Description, $PS, $Log, $Printer, $IOPort, $GSName, $JobSize, $RemoteName, $RemotePrinter) = @_;

#
# Location of files
#

$PrintcapPath = "/etc/printcap";
$NewPrintcapPath = "/etc/newprintcap";
$InputFilterPath = "/usr/local/libexec";

#
# Open the $PrintcapPath file for reading and
# open the $NewPrintcapPath for writing
#

open (FILE, $PrintcapPath);
open (FILE1, "> $NewPrintcapPath");

#
# If $Printer found skip previous settings
# and write changed settings
#

$FirstLine = 1;

while ($Line = <FILE>) {

    $OrgLine = $Line;
    $Line = remove_leading_space $Line;

    if ($Line !~ /^\#/) {

      if ($FirstLine) {

	if ($Line =~ /$Printer/) {

          #
          # Write the user choice in the file
          #

	  if (length($LP) > 0) {

	    if (!($Description =~ /$LP/)) {

	       $LP .= "\|";
	       $LP .= $Description;
	       $Description = $LP;
	    }
	  } else {
	      if ($Description =~ /lp\|/) {

		$Description =~ s/lp\|//;
		$Description =~ s/^\|//;
		$Description =~ s/\|$//;
		$Description =~ s/\|\|/\|/g;
	      }
	    }

          print FILE1 "$Description:\\\n";
          print FILE1 "  :sh:sd=$SpoolPath:\\\n";
          print FILE1 "  :lp=$IOPort:\\\n";

	  if (length($RemoteName) > 0) {

	    print FILE1 "  :rm=$RemoteName:\\\n";
	  }

	  if (length($RemotePrinter) > 0) {

	    print FILE1 "  :rp=$RemotePrinter:\\\n";
	  }

	  if ($PS eq "Yes") {

  	    print FILE1 "  :if=$InputFilterPath/$GSName:\\\n";
	  }

	  if ($Log eq "Yes") {
  
	    print FILE1 "  :lf=$SpoolPath/$GSName.log:\\\n";
	  }

	  if ($Job eq "No") {
  
	    print FILE1 "  :mx#0:\\\n";
	  } else {

	      if ((length($JobSize) > 0) && ($JobSize !~ /\D/)) {

      		print FILE1 "  :mx#$JobSize:\\\n";
	      } else {

		  print FILE1 "  :mx#1000:\\\n";
      		}
	    }

	  print FILE1 "  :sf:\n";
	  while ($Line =~ /\\$/) {

	    $Line = <FILE>;
	  }
	} else {

	    print FILE1 $OrgLine;
	    if ($Line =~ /\\$/) {

	      $FirstLine = 0;
	    }
	  }
      } else {

	  print FILE1 $OrgLine;
	  if ($Line !~ /\\$/) {

	      $FirstLine = 1;
	  }
	}
    } else {

	print FILE1 $OrgLine;
      }
}

#
# Close the file
#

close (FILE);
close (FILE1); 

#
# Overwrite the old $PrintcapPath with the modified one
#

system ("cp $NewPrintcapPath $PrintcapPath");

#
# remove the $NewPrintcapPath file
#

system ("rm $NewPrintcapPath");

}

# writechangedprinter.pm


