package writecustomkeymap;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(write_custom_keymap);

use Cwd;

use removeleadingspace;

#
# change a seleced keymap to a custom keymap for FreeBSB
# (C) 1997 by Wouter de Boer
#
# Usage:
#    write_custom_keymap arg1, arg2
#
#	arg1: Swap Backspace and Delete button
#	arg2: Swap Capslock and Left Control button
#

sub write_custom_keymap {

my($BSDel, $CLLCT) = @_;

$DirPath = cwd();
$DirPath =~ s/lib/Keyboard/;

system ("kbdcontrol -d >$DirPath/custom.kbd </dev/ttyv0");

if (length($BSDel) > 0) {

  open (FILE, "$DirPath/custom.kbd");
  open (FILE1, "> $DirPath/newcustom.kbd");

  while ($Line = <FILE>) {

    $String = remove_leading_space $Line;
    @TempArray = split (/ /, $String);
    $Number = $TempArray[0];

    if ($Line =~ /bs/) {

      print FILE1 "  $Number   del    '.'    '.'    '.'    '.'    '.'    boot   boot    N\n";
    } elsif ($Line =~ /del/) {

	print FILE1 "  $Number   bs     bs     del    del    bs     bs     del    del     O\n";
      } else {

	  print FILE1 "$Line";
	}
  }

  close (FILE);
  close (FILE1);

  system ("mv $DirPath/newcustom.kbd $DirPath/custom.kbd");   
} 

if (length($CLLCT) > 0) {

    open (FILE, "$DirPath/custom.kbd");
    open (FILE1, "> $DirPath/newcustom.kbd");

    while ($Line = <FILE>) {

    $String = remove_leading_space $Line;
    @TempArray = split (/ /, $String);
    $Number = $TempArray[0];

    if ($Line =~ /lctrl/) {

      print FILE1 "  $Number   clock  clock  clock  clock  clock  clock  clock  clock   O\n";
    } elsif ($Line =~ /clock/) {

	print FILE1 "  $Number   lctrl  lctrl  lctrl  lctrl  lctrl  lctrl  lctrl  lctrl   O\n";
      } else {

	  print FILE1 "$Line";
	}
  }

  close (FILE);
  close (FILE1);

  system ("mv $DirPath/newcustom.kbd $DirPath/custom.kbd");
 
}

system ("mv $DirPath/custom.kbd /usr/share/syscons/keymaps");

}

# writecustomkeymap.pm