package writepostscriptfile;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(write_postscript_file);

sub write_postscript_file {

#
# create if neseccary a postscript file
# (C) 1997 by Wouter de Boer
#
# Usage:
#    write_postscript_file arg1
#
#	arg1: GS Name
#

#
# Get group properties
#

my($GSName) = $_[0];

#
# Location of files
#

$InputFilterPath = "/usr/local/libexec";

#
# Mode used in this program
#

$ModeRX = 555;

#
# Test if input filter for printer exists. No ?? Create
#

if (!(-e "$InputFilterPath/$GSName")) {
    
  open (FILE, "> $InputFilterPath/$GSName");
  print FILE "#!/bin/sh\n";
  print FILE "#\n";
  print FILE "#  Print Ghostscript-simulated PostScript on a $Printer\n";
  print FILE "#  Installed in $InputFilter/$GSName\n";
  print FILE " \n";
  print FILE "#\n";
  print FILE "#  Treat LF as CR+LF\n";
  print FILE "#\n";
  print FILE "printf \"\033&k2G\" || exit 2\n";
  print FILE " \n";
  print FILE "#\n";
  print FILE "#  Read first two characters of the file\n";
  print FILE "#\n";
  print FILE "read first_line\n";
  print FILE "first_two_chars=\`expr \"\$first_line\" : \'\\(..\\)\'\`\n";
  print FILE " \n";
  print FILE "if [ \"\$first_two_chars\" = \"%!\" ]; then\n";
  print FILE "#\n";
  print FILE "#  It is PostScript; use Ghostscript to scan-convert and print it\n";
  print FILE "#\n";
  print FILE "/usr/local/bin/gs -dSAFER -dNOPAUSE -q -sDEVICE=$GSName -sOutputFile=- - \\\n";
  print FILE "&& exit 0\n";
  print FILE " \n";
  print FILE "else\n";
  print FILE "#\n";
  print FILE "#  Plain text or HP/PCL, so just print it directly; print a form\n";
  print FILE "#  at the end to eject the last page.\n";
  print FILE "#\n";
  print FILE "echo $first_line && cat && printf \"\f\" && exit 2\n";
  print FILE "fi\n";
  print FILE " \n";
  print FILE "exit 2\n";
  close(FILE);
    
  system("chmod $ModeRX $InputFilterPath/$GSName");
}

}

# writepostscriptfile.pm
